'*****************************************************************************
'                                                                            *
'  ActivateApp.bas                                                           *
'                                                                            *
'  This module file implements a Windows message handler for WM_ACTIVATEAPP, *
'  which is required to support Alt+Tab or other task switching in DirectX   *
'  applications.                                                             *
'                                                                            *
'  Requires Visual Basic 5.0 or later.                                       *
'                                                                            *
'*****************************************************************************

Public Const WM_ACTIVATEAPP = &H1C
Public Const GWL_WNDPROC = -4

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
   (ByVal lpPrevWndFunc As Long, ByVal hWindow As Long, ByVal iMsg As Long, _
    ByVal wParam As Long, ByVal lParam As Long) As Long

Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
   (ByVal hWindow As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Global lpPrevWndProc As Long

Public Sub HookWindowProc(hWindow As Long)
   lpPrevWndProc = SetWindowLong(hWindow, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub UnHookWindowProc(hWindow As Long)
   Dim lngReturnValue As Long
   lngReturnValue = SetWindowLong(hWindow, GWL_WNDPROC, lpPrevWndProc)
End Sub

Function WindowProc(ByVal hWindow As Long, ByVal iMsg As Long, _
                    ByVal wParam As Long, ByVal lParam As Long) As Long
   Select Case iMsg

      Case WM_ACTIVATEAPP
         Call Form1.ActivateApp(wParam)
         WindowProc = 0

      Case Else
         WindowProc = CallWindowProc(lpPrevWndProc, hWindow, iMsg, wParam, lParam)

   End Select
End Function
