/****************************************************************************\
*                                                                            *
*  FGWIN.H                                                                   *
*                                                                            *
*  This file contains the C and C++ function prototypes for Fastgraph/Light  *
*  6.03 for Windows.                                                         *
*                                                                            *
*  Copyright (c) 1991-2003 Ted Gruber Software.  All rights reserved.        *
*                                                                            *
\****************************************************************************/

#ifndef __FGWIN_H

#define __FGWIN_H

#ifndef _WINDOWS_
#include <windows.h>       /* Include WINDOWS.H if not already included */
#endif

#ifdef _MSC_VER            /* Microsoft Visual C++ */
#define _export
#endif

#ifdef __WATCOMC__         /* Watcom C/C++ */
#ifdef _export
#undef _export
#define _export
#endif
#endif

#ifdef __BORLANDC__        /* Borland C++ and C++Builder */
#define DLLIMPORT
#else
#define DLLIMPORT __declspec(dllimport)
#endif

#define FG32
#define FG_APIENTRY __stdcall

#define byteptr char *
#define dblptr  double *
#define hugeptr char *
#define intptr  int *
#define longptr long *
#define voidptr void *

/* fg_3Drenderstate() bit flags */
#define FG_LINEAR_TM      0
#define FG_PERSPECTIVE_TM 1
#define FG_WIREFRAME      2
#define FG_ZBUFFER        4
#define FG_ZCLIP          8

/* image file bit flags */
#define FG_IGNOREPALETTE  1
#define FG_AT_XY          2
#define FG_FROMBUFFER     4
#define FG_KEEPCOLORS     8
#define FG_NODELAY        1
#define FG_IGNOREAVIPALETTE  16
#define FG_IGNOREFLICPALETTE 16

/* fg_ddsetup() bit flags */
#define FG_DX_BLIT        0
#define FG_DX_FLIP        1
#define FG_DX_RENDER_FG   0
#define FG_DX_RENDER_SW   2
#define FG_DX_RENDER_HW   4
#define FG_DX_ZBUFFER     8
#define FG_DX_TCDEPTH    16

/* fg_3Dgetmatrix() and fg_3Dsetmatrix() constants */
#define FG_OBJECT_ROTATION    0
#define FG_OBJECT_TRANSLATION 1
#define FG_OBJECT_TRANSFORM   2
#define FG_WORLD_ROTATION     3
#define FG_WORLD_TRANSLATION  4
#define FG_WORLD_TRANSFORM    5
#define FG_COMBINED_TRANSFORM 6

#ifdef __cplusplus
extern "C" {
#endif

DLLIMPORT int      FG_APIENTRY fg_3Daxisangle (double, double, double, int);
DLLIMPORT int      FG_APIENTRY fg_3Daxisangleobject (double, double, double, int);
DLLIMPORT int      FG_APIENTRY fg_3Dbehindviewer (double, double, double, double);
DLLIMPORT void     FG_APIENTRY fg_3Dgetmatrix (dblptr, int);
DLLIMPORT void     FG_APIENTRY fg_3Dgetpov (dblptr, dblptr, dblptr, dblptr, dblptr, dblptr);
DLLIMPORT void     FG_APIENTRY fg_3Dline (double, double, double, double, double, double);
DLLIMPORT int      FG_APIENTRY fg_3Dlookat (double, double, double, double, double, double);
DLLIMPORT void     FG_APIENTRY fg_3Dmove (double, double, double);
DLLIMPORT void     FG_APIENTRY fg_3Dmoveforward (double);
DLLIMPORT void     FG_APIENTRY fg_3Dmoveforwardobject (double);
DLLIMPORT void     FG_APIENTRY fg_3Dmoveobject (double, double, double);
DLLIMPORT void     FG_APIENTRY fg_3Dmoveright (double);
DLLIMPORT void     FG_APIENTRY fg_3Dmoverightobject (double);
DLLIMPORT void     FG_APIENTRY fg_3Dmoveup (double);
DLLIMPORT void     FG_APIENTRY fg_3Dmoveupobject (double);
DLLIMPORT void     FG_APIENTRY fg_3Dpolygon (dblptr, int);
DLLIMPORT void     FG_APIENTRY fg_3Dpolygonobject (dblptr, int);
DLLIMPORT void     FG_APIENTRY fg_3Dpov (double, double, double, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_3Dproject (dblptr, intptr, int);
DLLIMPORT void     FG_APIENTRY fg_3Drenderstate (int);
DLLIMPORT void     FG_APIENTRY fg_3Droll (int);
DLLIMPORT void     FG_APIENTRY fg_3Drollobject (int);
DLLIMPORT int      FG_APIENTRY fg_3Drotate (double, double, double);
DLLIMPORT int      FG_APIENTRY fg_3Drotateobject (double, double, double);
DLLIMPORT void     FG_APIENTRY fg_3Drotateright (int);
DLLIMPORT void     FG_APIENTRY fg_3Drotaterightobject (int);
DLLIMPORT void     FG_APIENTRY fg_3Drotateup (int);
DLLIMPORT void     FG_APIENTRY fg_3Drotateupobject (int);
DLLIMPORT void     FG_APIENTRY fg_3Dsetmatrix (dblptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_3Dsetobject (double, double, double, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_3Dsetzclip (double, double);
DLLIMPORT void     FG_APIENTRY fg_3Dshade (dblptr, byteptr, int);
DLLIMPORT void     FG_APIENTRY fg_3Dshadeobject (dblptr, byteptr, int);
DLLIMPORT void     FG_APIENTRY fg_3Dtexturemap (dblptr, voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_3Dtexturemapobject (dblptr, voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_3Dtransform (dblptr, dblptr, int);
DLLIMPORT void     FG_APIENTRY fg_3Dtransformobject (dblptr, dblptr, int);
DLLIMPORT void     FG_APIENTRY fg_3Dupvector (double, double, double);
DLLIMPORT void     FG_APIENTRY fg_3Dviewport (int, int, int, int, double);
DLLIMPORT int      FG_APIENTRY fg_3Dzclip (dblptr, dblptr, int);
DLLIMPORT int      FG_APIENTRY fg_3Dzcliprgb (dblptr, dblptr, byteptr, byteptr, int);
DLLIMPORT int      FG_APIENTRY fg_3Dzcliptm (dblptr, dblptr, voidptr, voidptr, int);

DLLIMPORT void     FG_APIENTRY fg_arc (int, int, int);
DLLIMPORT void     FG_APIENTRY fg_arcw (double, int, int);
DLLIMPORT void     FG_APIENTRY fg_avidone (voidptr);
DLLIMPORT int      FG_APIENTRY fg_aviframe (voidptr, voidptr);
DLLIMPORT int      FG_APIENTRY fg_avihead (byteptr, voidptr);
DLLIMPORT int      FG_APIENTRY fg_avimake (byteptr, voidptr, int, int, int, int, int, int);
DLLIMPORT int      FG_APIENTRY fg_aviopen (byteptr, voidptr);
DLLIMPORT int      FG_APIENTRY fg_avipal (byteptr, voidptr);
DLLIMPORT int      FG_APIENTRY fg_aviplay (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_avisize (voidptr, intptr, intptr);
DLLIMPORT int      FG_APIENTRY fg_aviskip (voidptr, int);

DLLIMPORT int      FG_APIENTRY fg_blend (int, int);
DLLIMPORT int      FG_APIENTRY fg_blend50 (int, int);
DLLIMPORT void     FG_APIENTRY fg_blenddcb (voidptr, voidptr, voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_blendvar (voidptr, voidptr, voidptr, voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_blendvb (voidptr, voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_blendvbv (voidptr, voidptr, voidptr, int, int);
DLLIMPORT int      FG_APIENTRY fg_bmphead (byteptr, voidptr);
DLLIMPORT int      FG_APIENTRY fg_bmppal (byteptr, voidptr);
DLLIMPORT void     FG_APIENTRY fg_bmpsize (voidptr, intptr, intptr);
DLLIMPORT void     FG_APIENTRY fg_box (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_boxdepth (int, int);
DLLIMPORT void     FG_APIENTRY fg_boxw (double, double, double, double);
DLLIMPORT void     FG_APIENTRY fg_boxx (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_boxxw (double, double, double, double);

DLLIMPORT void     FG_APIENTRY fg_circle (int);
DLLIMPORT void     FG_APIENTRY fg_circlef (int);
DLLIMPORT void     FG_APIENTRY fg_circlefw (double);
DLLIMPORT void     FG_APIENTRY fg_circlew (double);
DLLIMPORT int      FG_APIENTRY fg_clip2vb (int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_clipdcb (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_clipmap (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_clipmask (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_clpimage (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_clprect (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_clprectw (double, double, double, double);
DLLIMPORT void     FG_APIENTRY fg_clprectx (int, int, int, int);
DLLIMPORT int      FG_APIENTRY fg_colors (void);
DLLIMPORT void     FG_APIENTRY fg_contdcb (voidptr, voidptr, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_contrgb (voidptr, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_contvb (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_copypage (int, int);
DLLIMPORT void     FG_APIENTRY fg_cut (voidptr, voidptr, int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_cutdcb (voidptr, voidptr, int, int, int, int, int);

DLLIMPORT void     FG_APIENTRY fg_dash (int, int, int);
DLLIMPORT void     FG_APIENTRY fg_dashrel (int, int, int);
DLLIMPORT void     FG_APIENTRY fg_dashrw (double, double, int);
DLLIMPORT void     FG_APIENTRY fg_dashw (double, double, int);
DLLIMPORT void     FG_APIENTRY fg_ddapply (int);
DLLIMPORT int      FG_APIENTRY fg_ddflip (void);
DLLIMPORT int      FG_APIENTRY fg_ddflipnw (void);
DLLIMPORT void     FG_APIENTRY fg_ddframe (int);
DLLIMPORT void     FG_APIENTRY fg_ddfreedc (HDC);
DLLIMPORT HDC      FG_APIENTRY fg_ddgetdc (void);
DLLIMPORT int      FG_APIENTRY fg_ddgetobj (int);
DLLIMPORT int      FG_APIENTRY fg_ddgetversion (void);
DLLIMPORT int      FG_APIENTRY fg_ddlock (void);
DLLIMPORT void     FG_APIENTRY fg_ddmemory (int);
DLLIMPORT void     FG_APIENTRY fg_ddrestore (void);
DLLIMPORT void     FG_APIENTRY fg_ddsetblt (int);
DLLIMPORT void     FG_APIENTRY fg_ddsetobj (voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_ddsetup (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_ddsetversion (int, int);
DLLIMPORT int      FG_APIENTRY fg_ddstatus (void);
DLLIMPORT void     FG_APIENTRY fg_ddunlock (void);
DLLIMPORT int      FG_APIENTRY fg_ddusage (void);
DLLIMPORT void     FG_APIENTRY fg_defcolor (int, int);
DLLIMPORT HPALETTE FG_APIENTRY fg_defpal (void);
DLLIMPORT void     FG_APIENTRY fg_dispfile (byteptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_display (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_displayp (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_draw (int, int);
DLLIMPORT void     FG_APIENTRY fg_drawdcb (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_drawmap (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_drawmask (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_drawrel (int, int);
DLLIMPORT void     FG_APIENTRY fg_drawrelx (int, int);
DLLIMPORT void     FG_APIENTRY fg_drawrw (double, double);
DLLIMPORT void     FG_APIENTRY fg_drawrxw (double, double);
DLLIMPORT void     FG_APIENTRY fg_draww (double, double);
DLLIMPORT void     FG_APIENTRY fg_drawx (int, int);
DLLIMPORT void     FG_APIENTRY fg_drawxw (double, double);
DLLIMPORT void     FG_APIENTRY fg_drawz (int, int, double, double);
DLLIMPORT void     FG_APIENTRY fg_drect (int, int, int, int, voidptr);
DLLIMPORT void     FG_APIENTRY fg_drectw (double, double, double, double, voidptr);
DLLIMPORT void     FG_APIENTRY fg_drwimage (voidptr, int, int);

DLLIMPORT void     FG_APIENTRY fg_ellipse (int, int);
DLLIMPORT void     FG_APIENTRY fg_ellipsef (int, int);
DLLIMPORT void     FG_APIENTRY fg_ellipsew (double, double);
DLLIMPORT void     FG_APIENTRY fg_ellipsfw (double, double);
DLLIMPORT void     FG_APIENTRY fg_erase (void);

DLLIMPORT void     FG_APIENTRY fg_fillpage (void);
DLLIMPORT int      FG_APIENTRY fg_findrgb (int, int, int);
DLLIMPORT long     FG_APIENTRY fg_fixdiv (long, long);
DLLIMPORT long     FG_APIENTRY fg_fixed (double);
DLLIMPORT long     FG_APIENTRY fg_fixmul (long, long);
DLLIMPORT void     FG_APIENTRY fg_fixtrig (int, longptr, longptr);
DLLIMPORT void     FG_APIENTRY fg_flicdone (voidptr);
DLLIMPORT int      FG_APIENTRY fg_flichead (byteptr, voidptr);
DLLIMPORT int      FG_APIENTRY fg_flicopen (byteptr, voidptr);
DLLIMPORT int      FG_APIENTRY fg_flicplay (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_flicsize (voidptr, intptr, intptr);
DLLIMPORT int      FG_APIENTRY fg_flicskip (voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_flipdcb (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_flipmask (voidptr, int, int);
DLLIMPORT double   FG_APIENTRY fg_float (long);
DLLIMPORT void     FG_APIENTRY fg_flood (int, int);
DLLIMPORT void     FG_APIENTRY fg_floodw (double, double);
DLLIMPORT void     FG_APIENTRY fg_flpimage (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_fontdc (HDC);
DLLIMPORT void     FG_APIENTRY fg_fontload (int);

DLLIMPORT void     FG_APIENTRY fg_gammadcb (voidptr, voidptr, double, int);
DLLIMPORT void     FG_APIENTRY fg_gammargb (voidptr, double, int);
DLLIMPORT void     FG_APIENTRY fg_gammavb (double, int, int);
DLLIMPORT void     FG_APIENTRY fg_gdiflip (void);
DLLIMPORT void     FG_APIENTRY fg_getblock (voidptr, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_getclip (intptr, intptr, intptr, intptr);
DLLIMPORT long     FG_APIENTRY fg_getclock (void);
DLLIMPORT int      FG_APIENTRY fg_getcolor (void);
DLLIMPORT void     FG_APIENTRY fg_getdacs (int, int, voidptr);
DLLIMPORT HDC      FG_APIENTRY fg_getdc (void);
DLLIMPORT void     FG_APIENTRY fg_getdcb (voidptr, int, int);
DLLIMPORT int      FG_APIENTRY fg_getdepth (void);
DLLIMPORT int      FG_APIENTRY fg_gethcbpp (void);
DLLIMPORT int      FG_APIENTRY fg_gethpage (void);
DLLIMPORT void     FG_APIENTRY fg_getimage (voidptr, int, int);
DLLIMPORT int      FG_APIENTRY fg_getindex (int);
DLLIMPORT long     FG_APIENTRY fg_getline (int);
DLLIMPORT int      FG_APIENTRY fg_getlines (void);
DLLIMPORT void     FG_APIENTRY fg_getmap (voidptr, int, int);
DLLIMPORT int      FG_APIENTRY fg_getmaxx (void);
DLLIMPORT int      FG_APIENTRY fg_getmaxy (void);
DLLIMPORT int      FG_APIENTRY fg_getpage (void);
DLLIMPORT int      FG_APIENTRY fg_getpixel (int, int);
DLLIMPORT void     FG_APIENTRY fg_getrgb (int, intptr, intptr, intptr);
DLLIMPORT void     FG_APIENTRY fg_getview (intptr, intptr, intptr, intptr, intptr, intptr, intptr, intptr);
DLLIMPORT void     FG_APIENTRY fg_getworld (dblptr, dblptr, dblptr, dblptr);
DLLIMPORT int      FG_APIENTRY fg_getxbox (void);
DLLIMPORT int      FG_APIENTRY fg_getxjust (void);
DLLIMPORT int      FG_APIENTRY fg_getxpos (void);
DLLIMPORT int      FG_APIENTRY fg_getybox (void);
DLLIMPORT int      FG_APIENTRY fg_getyjust (void);
DLLIMPORT int      FG_APIENTRY fg_getypos (void);
DLLIMPORT void     FG_APIENTRY fg_gouraud (intptr, byteptr, int);
DLLIMPORT void     FG_APIENTRY fg_gouraudz (intptr, byteptr, dblptr, int);
DLLIMPORT void     FG_APIENTRY fg_graydcb (voidptr, voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_grayrgb (voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_grayvb (int, int);

DLLIMPORT void     FG_APIENTRY fg_imagebuf (voidptr, UINT);
DLLIMPORT long     FG_APIENTRY fg_imagesiz (int, int);
DLLIMPORT void     FG_APIENTRY fg_initw (void);
DLLIMPORT int      FG_APIENTRY fg_inside (intptr, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_invdcb (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_invert (voidptr, int, int);

DLLIMPORT void     FG_APIENTRY fg_jpegbuf (voidptr, UINT);
DLLIMPORT int      FG_APIENTRY fg_jpeghead (byteptr, voidptr);
DLLIMPORT int      FG_APIENTRY fg_jpegmem (voidptr);
DLLIMPORT void     FG_APIENTRY fg_jpegsize (voidptr, intptr, intptr);
DLLIMPORT void     FG_APIENTRY fg_justify (int, int);

DLLIMPORT int      FG_APIENTRY fg_kbtest (int);

DLLIMPORT int      FG_APIENTRY fg_loadpcx (byteptr, int);
DLLIMPORT void     FG_APIENTRY fg_locate (int, int);
DLLIMPORT void     FG_APIENTRY fg_logfont (HFONT);
DLLIMPORT HPALETTE FG_APIENTRY fg_logpal (int, int, voidptr);

DLLIMPORT int      FG_APIENTRY fg_makebmp (int, int, int, int, int, byteptr);
DLLIMPORT int      FG_APIENTRY fg_makepcx (int, int, int, int, byteptr);
DLLIMPORT int      FG_APIENTRY fg_makeppr (int, int, int, int, byteptr);
DLLIMPORT int      FG_APIENTRY fg_makespr (int, int, int, int, byteptr);
DLLIMPORT void     FG_APIENTRY fg_mapdacs (voidptr, voidptr, int);
DLLIMPORT int      FG_APIENTRY fg_maprgb (int, int, int);
DLLIMPORT UINT     FG_APIENTRY fg_measure (void);
DLLIMPORT long     FG_APIENTRY fg_memavail (void);
DLLIMPORT int      FG_APIENTRY fg_modeset (int, int, int, int);
DLLIMPORT int      FG_APIENTRY fg_modetest (int, int, int);
DLLIMPORT void     FG_APIENTRY fg_mousecur (HCURSOR);
DLLIMPORT int      FG_APIENTRY fg_mouseini (void);
DLLIMPORT void     FG_APIENTRY fg_mouselim (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_mousemov (int, int);
DLLIMPORT void     FG_APIENTRY fg_mousepos (intptr, intptr);
DLLIMPORT HCURSOR  FG_APIENTRY fg_mouseptr (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_mousesiz (int);
DLLIMPORT void     FG_APIENTRY fg_mousevis (int);
DLLIMPORT void     FG_APIENTRY fg_move (int, int);
DLLIMPORT void     FG_APIENTRY fg_move3d (longptr, long, long, long, int);
DLLIMPORT void     FG_APIENTRY fg_moverel (int, int);
DLLIMPORT void     FG_APIENTRY fg_moverw (double, double);
DLLIMPORT void     FG_APIENTRY fg_movew (double, double);

DLLIMPORT void     FG_APIENTRY fg_opacity (int);

DLLIMPORT void     FG_APIENTRY fg_pack (voidptr, voidptr, int, int);
DLLIMPORT long     FG_APIENTRY fg_pagesize (int, int);
DLLIMPORT void     FG_APIENTRY fg_paint (int, int);
DLLIMPORT void     FG_APIENTRY fg_paintw (double, double);
DLLIMPORT void     FG_APIENTRY fg_paste (voidptr, voidptr, int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_pastedcb (voidptr, voidptr, int, int, int, int, int);
DLLIMPORT int      FG_APIENTRY fg_pcxhead (byteptr, voidptr);
DLLIMPORT int      FG_APIENTRY fg_pcxpal (byteptr, voidptr);
DLLIMPORT void     FG_APIENTRY fg_pcxrange (voidptr, intptr, intptr, intptr, intptr);
DLLIMPORT void     FG_APIENTRY fg_pcxsize (voidptr, intptr, intptr);
DLLIMPORT void     FG_APIENTRY fg_photodcb (voidptr, voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_photorgb (voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_photovb (int, int);
DLLIMPORT void     FG_APIENTRY fg_point (int, int);
DLLIMPORT void     FG_APIENTRY fg_pointw (double, double);
DLLIMPORT void     FG_APIENTRY fg_pointx (int, int);
DLLIMPORT void     FG_APIENTRY fg_pointxw (double, double);
DLLIMPORT void     FG_APIENTRY fg_polyedge (int);
DLLIMPORT void     FG_APIENTRY fg_polyfill (intptr, voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_polyfilz (intptr, dblptr, int);
DLLIMPORT void     FG_APIENTRY fg_polygon (intptr, intptr, int);
DLLIMPORT void     FG_APIENTRY fg_polygonw (dblptr, dblptr, int);
DLLIMPORT void     FG_APIENTRY fg_polyline (intptr, int);
DLLIMPORT void     FG_APIENTRY fg_polyoff (int, int);
DLLIMPORT void     FG_APIENTRY fg_print (byteptr, int);
DLLIMPORT void     FG_APIENTRY fg_printdc (HDC);
DLLIMPORT int      FG_APIENTRY fg_printer (int);
DLLIMPORT void     FG_APIENTRY fg_project (longptr, longptr, intptr, int);
DLLIMPORT void     FG_APIENTRY fg_putblock (voidptr, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_putdcb (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_putimage (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_putpixel (int, int);

DLLIMPORT void     FG_APIENTRY fg_realize (HPALETTE);
DLLIMPORT void     FG_APIENTRY fg_rect (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_rectw (double, double, double, double);
DLLIMPORT void     FG_APIENTRY fg_rectx (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_reduce (int, int, voidptr);
DLLIMPORT void     FG_APIENTRY fg_restore (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_restorew (double, double, double, double);
DLLIMPORT void     FG_APIENTRY fg_revdcb (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_revimage (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_revmask (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_rotate (voidptr, voidptr, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_rotate3d (longptr, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_rotdcb (voidptr, voidptr, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_rotsize (int, int, int, intptr, intptr);

DLLIMPORT void     FG_APIENTRY fg_save (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_savew (double, double, double, double);
DLLIMPORT void     FG_APIENTRY fg_scale (voidptr, voidptr, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_scaledcb (voidptr, voidptr, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_scroll (int, int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_setalpha (int);
DLLIMPORT void     FG_APIENTRY fg_setangle (double);
DLLIMPORT void     FG_APIENTRY fg_setclip (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_setclipw (double, double, double, double);
DLLIMPORT void     FG_APIENTRY fg_setcolor (int);
DLLIMPORT void     FG_APIENTRY fg_setcolorrgb (int, int, int);
DLLIMPORT void     FG_APIENTRY fg_setdacs (int, int, voidptr);
DLLIMPORT void     FG_APIENTRY fg_setdc (HDC);
DLLIMPORT void     FG_APIENTRY fg_sethpage (int);
DLLIMPORT void     FG_APIENTRY fg_setpage (int);
DLLIMPORT void     FG_APIENTRY fg_setratio (double);
DLLIMPORT void     FG_APIENTRY fg_setrgb (int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_setsize (int);
DLLIMPORT void     FG_APIENTRY fg_setsizew (double);
DLLIMPORT void     FG_APIENTRY fg_setview (int, int, int, int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_setworld (double, double, double, double);
DLLIMPORT void     FG_APIENTRY fg_shear (voidptr, voidptr, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_sheardcb (voidptr, voidptr, int, int, int, int);
DLLIMPORT int      FG_APIENTRY fg_showavi (byteptr, int, int);
DLLIMPORT int      FG_APIENTRY fg_showbmp (byteptr, int);
DLLIMPORT int      FG_APIENTRY fg_showflic (byteptr, int, int);
DLLIMPORT int      FG_APIENTRY fg_showjpeg (byteptr, int);
DLLIMPORT int      FG_APIENTRY fg_showpcx (byteptr, int);
DLLIMPORT int      FG_APIENTRY fg_showppr (byteptr, int);
DLLIMPORT int      FG_APIENTRY fg_showspr (byteptr, int);
DLLIMPORT void     FG_APIENTRY fg_stall (int);
DLLIMPORT void     FG_APIENTRY fg_swchar (byteptr, int, int);
DLLIMPORT double   FG_APIENTRY fg_swlength (byteptr, int);
DLLIMPORT void     FG_APIENTRY fg_swtext (byteptr, int, int);

DLLIMPORT void     FG_APIENTRY fg_tcdefine (int, int);
DLLIMPORT void     FG_APIENTRY fg_tcmask (int);
DLLIMPORT void     FG_APIENTRY fg_tcxfer (int, int, int, int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_texmap (intptr, voidptr, int);
DLLIMPORT void     FG_APIENTRY fg_texmapp (intptr, voidptr, dblptr, int);
DLLIMPORT void     FG_APIENTRY fg_texmappz (intptr, voidptr, dblptr, int);
DLLIMPORT void     FG_APIENTRY fg_texmapz (intptr, voidptr, dblptr, int);
DLLIMPORT void     FG_APIENTRY fg_text (byteptr, int);
DLLIMPORT void     FG_APIENTRY fg_texture (voidptr, int);
DLLIMPORT int      FG_APIENTRY fg_tmdefine (voidptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_tmevict (void);
DLLIMPORT void     FG_APIENTRY fg_tmfree (int);
DLLIMPORT int      FG_APIENTRY fg_tminit (int);
DLLIMPORT void     FG_APIENTRY fg_tmselect (int);
DLLIMPORT void     FG_APIENTRY fg_tmspan (int);
DLLIMPORT void     FG_APIENTRY fg_tmtransparency (int);
DLLIMPORT void     FG_APIENTRY fg_tmunits (int);
DLLIMPORT void     FG_APIENTRY fg_transdcb (voidptr, voidptr, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_transfer (int, int, int, int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_trig (int, dblptr, dblptr);

DLLIMPORT void     FG_APIENTRY fg_unmaprgb (int, intptr, intptr, intptr);
DLLIMPORT void     FG_APIENTRY fg_unpack (voidptr, voidptr, int);

DLLIMPORT int      FG_APIENTRY fg_vb2clip (int, int, int, int);
DLLIMPORT long     FG_APIENTRY fg_vbaddr (int);
DLLIMPORT int      FG_APIENTRY fg_vballoc (int, int);
DLLIMPORT void     FG_APIENTRY fg_vbclose (void);
DLLIMPORT void     FG_APIENTRY fg_vbcolors (void);
DLLIMPORT void     FG_APIENTRY fg_vbcopy (int, int, int, int, int, int, int, int);
DLLIMPORT int      FG_APIENTRY fg_vbdefine (hugeptr, int, int);
DLLIMPORT void     FG_APIENTRY fg_vbdepth (int);
DLLIMPORT void     FG_APIENTRY fg_vbfin (void);
DLLIMPORT void     FG_APIENTRY fg_vbfree (int);
DLLIMPORT int      FG_APIENTRY fg_vbhandle (void);
DLLIMPORT int      FG_APIENTRY fg_vbinit (void);
DLLIMPORT int      FG_APIENTRY fg_vbopen (int);
DLLIMPORT void     FG_APIENTRY fg_vbpaste (int, int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_vbprint (int, int, int, int, int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_vbscale (int, int, int, int, int, int, int, int);
DLLIMPORT long     FG_APIENTRY fg_vbsize (int, int);
DLLIMPORT void     FG_APIENTRY fg_vbtccopy (int, int, int, int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_vbtcopy (int, int, int, int, int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_vbtzcopy (int, int, int, int, int, int, int, int);
DLLIMPORT void     FG_APIENTRY fg_vbundef (int);
DLLIMPORT void     FG_APIENTRY fg_version (intptr, intptr);
DLLIMPORT void     FG_APIENTRY fg_view3d (int, int, int, int, long);

DLLIMPORT void     FG_APIENTRY fg_waitfor (int);
DLLIMPORT void     FG_APIENTRY fg_where (intptr, intptr);

DLLIMPORT int      FG_APIENTRY fg_xalpha (int);
DLLIMPORT int      FG_APIENTRY fg_xclient (int);
DLLIMPORT int      FG_APIENTRY fg_xconvert (int);
DLLIMPORT int      FG_APIENTRY fg_xscreen (double);
DLLIMPORT int      FG_APIENTRY fg_xvb (int);
DLLIMPORT int      FG_APIENTRY fg_xview (int);
DLLIMPORT double   FG_APIENTRY fg_xworld (int);

DLLIMPORT int      FG_APIENTRY fg_yalpha (int);
DLLIMPORT int      FG_APIENTRY fg_yclient (int);
DLLIMPORT int      FG_APIENTRY fg_yconvert (int);
DLLIMPORT int      FG_APIENTRY fg_yscreen (double);
DLLIMPORT int      FG_APIENTRY fg_yvb (int);
DLLIMPORT int      FG_APIENTRY fg_yview (int);
DLLIMPORT double   FG_APIENTRY fg_yworld (int);

DLLIMPORT int      FG_APIENTRY fg_zballoc (int, int);
DLLIMPORT void     FG_APIENTRY fg_zbframe (void);
DLLIMPORT void     FG_APIENTRY fg_zbfree (int);
DLLIMPORT void     FG_APIENTRY fg_zbopen (int);

#ifdef __cplusplus
}
#endif

#endif                     /* of #ifndef __FGWIN_H */
