'*****************************************************************************
'                                                                            *
'  FGWin.inc                                                                 *
'                                                                            *
'  This file contains the PowerBASIC function declarations for the           *
'  Fastgraph/Light 6.03 for Windows native libraries.                        *
'                                                                            *
'  Copyright (c) 2000-2003 Ted Gruber Software.  All rights reserved.        *
'                                                                            *
'*****************************************************************************

#IF NOT %DEF(%FGWIN_INC)

%FGWIN_INC = 1

#IF NOT %DEF(%WINAPI)
#INCLUDE "WIN32API.INC"   ' include WIN32API.INC if not already included
#ENDIF

' fg_3Drenderstate() bit flags
%FG_LINEAR_TM = 0
%FG_PERSPECTIVE_TM = 1
%FG_WIREFRAME = 2
%FG_ZBUFFER = 4
%FG_ZCLIP = 8

' image file bit flags
%FG_IGNOREPALETTE = 1
%FG_AT_XY = 2
%FG_FROMBUFFER = 4
%FG_KEEPCOLORS = 8
%FG_NODELAY = 1
%FG_IGNOREAVIPALETTE = 16
%FG_IGNOREFLICPALETTE = 16

' fg_3Dgetmatrix() and fg_3Dsetmatrix() constants
%FG_OBJECT_ROTATION = 0
%FG_OBJECT_TRANSLATION = 1
%FG_OBJECT_TRANSFORM = 2
%FG_WORLD_ROTATION = 3
%FG_WORLD_TRANSLATION = 4
%FG_WORLD_TRANSFORM = 5
%FG_COMBINED_TRANSFORM = 6

DECLARE FUNCTION fg_3Daxisangle LIB "fgw32.dll" ALIAS "_fg_3Daxisangle@28" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS LONG) AS LONG
DECLARE FUNCTION fg_3Daxisangleobject LIB "fgw32.dll" ALIAS "_fg_3Daxisangleobject@28" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS LONG) AS LONG
DECLARE FUNCTION fg_3Dbehindviewer LIB "fgw32.dll" ALIAS "_fg_3Dbehindviewer@32" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE) AS LONG
DECLARE SUB      fg_3Dgetmatrix LIB "fgw32.dll" ALIAS "_fg_3Dgetmatrix@8" _
                    (Arg1 AS DOUBLE, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_3Dgetpov LIB "fgw32.dll" ALIAS "_fg_3Dgetpov@24" _
                    (Arg1 AS DOUBLE, Arg2 AS DOUBLE, Arg3 AS DOUBLE, Arg4 AS DOUBLE, Arg5 AS DOUBLE, Arg6 AS DOUBLE)
DECLARE SUB      fg_3Dline LIB "fgw32.dll" ALIAS "_fg_3Dline@48" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE, BYVAL Arg5 AS DOUBLE, BYVAL Arg6 AS DOUBLE)
DECLARE FUNCTION fg_3Dlookat LIB "fgw32.dll" ALIAS "_fg_3Dlookat@48" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE, BYVAL Arg5 AS DOUBLE, BYVAL Arg6 AS DOUBLE) AS LONG
DECLARE SUB      fg_3Dmove LIB "fgw32.dll" ALIAS "_fg_3Dmove@24" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE)
DECLARE SUB      fg_3Dmoveforward LIB "fgw32.dll" ALIAS "_fg_3Dmoveforward@8" _
                    (BYVAL Arg1 AS DOUBLE)
DECLARE SUB      fg_3Dmoveforwardobject LIB "fgw32.dll" ALIAS "_fg_3Dmoveforwardobject@8" _
                    (BYVAL Arg1 AS DOUBLE)
DECLARE SUB      fg_3Dmoveobject LIB "fgw32.dll" ALIAS "_fg_3Dmoveobject@24" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE)
DECLARE SUB      fg_3Dmoveright LIB "fgw32.dll" ALIAS "_fg_3Dmoveright@8" _
                    (BYVAL Arg1 AS DOUBLE)
DECLARE SUB      fg_3Dmoverightobject LIB "fgw32.dll" ALIAS "_fg_3Dmoverightobject@8" _
                    (BYVAL Arg1 AS DOUBLE)
DECLARE SUB      fg_3Dmoveup LIB "fgw32.dll" ALIAS "_fg_3Dmoveup@8" _
                    (BYVAL Arg1 AS DOUBLE)
DECLARE SUB      fg_3Dmoveupobject LIB "fgw32.dll" ALIAS "_fg_3Dmoveupobject@8" _
                    (BYVAL Arg1 AS DOUBLE)
DECLARE SUB      fg_3Dpolygon LIB "fgw32.dll" ALIAS "_fg_3Dpolygon@8" _
                    (Arg1 AS DOUBLE, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_3Dpolygonobject LIB "fgw32.dll" ALIAS "_fg_3Dpolygonobject@8" _
                    (Arg1 AS DOUBLE, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_3Dpov LIB "fgw32.dll" ALIAS "_fg_3Dpov@36" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG)
DECLARE SUB      fg_3Dproject LIB "fgw32.dll" ALIAS "_fg_3Dproject@12" _
                    (Arg1 AS DOUBLE, Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_3Drenderstate LIB "fgw32.dll" ALIAS "_fg_3Drenderstate@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_3Droll LIB "fgw32.dll" ALIAS "_fg_3Droll@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_3Drollobject LIB "fgw32.dll" ALIAS "_fg_3Drollobject@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE FUNCTION fg_3Drotate LIB "fgw32.dll" ALIAS "_fg_3Drotate@24" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE) AS LONG
DECLARE FUNCTION fg_3Drotateobject LIB "fgw32.dll" ALIAS "_fg_3Drotateobject@24" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE) AS LONG
DECLARE SUB      fg_3Drotateright LIB "fgw32.dll" ALIAS "_fg_3Drotateright@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_3Drotaterightobject LIB "fgw32.dll" ALIAS "_fg_3Drotaterightobject@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_3Drotateup LIB "fgw32.dll" ALIAS "_fg_3Drotateup@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_3Drotateupobject LIB "fgw32.dll" ALIAS "_fg_3Drotateupobject@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_3Dsetmatrix LIB "fgw32.dll" ALIAS "_fg_3Dsetmatrix@12" _
                    (Arg1 AS DOUBLE, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_3Dsetobject LIB "fgw32.dll" ALIAS "_fg_3Dsetobject@36" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG)
DECLARE SUB      fg_3Dsetzclip LIB "fgw32.dll" ALIAS "_fg_3Dsetzclip@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_3Dshade LIB "fgw32.dll" ALIAS "_fg_3Dshade@12" _
                    (Arg1 AS DOUBLE, Arg2 AS BYTE, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_3Dshadeobject LIB "fgw32.dll" ALIAS "_fg_3Dshadeobject@12" _
                    (Arg1 AS DOUBLE, Arg2 AS BYTE, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_3Dtexturemap LIB "fgw32.dll" ALIAS "_fg_3Dtexturemap@12" _
                    (Arg1 AS DOUBLE, Arg2 AS ANY, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_3Dtexturemapobject LIB "fgw32.dll" ALIAS "_fg_3Dtexturemapobject@12" _
                    (Arg1 AS DOUBLE, Arg2 AS ANY, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_3Dtransform LIB "fgw32.dll" ALIAS "_fg_3Dtransform@12" _
                    (Arg1 AS DOUBLE, Arg2 AS DOUBLE, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_3Dtransformobject LIB "fgw32.dll" ALIAS "_fg_3Dtransformobject@12" _
                    (Arg1 AS DOUBLE, Arg2 AS DOUBLE, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_3Dupvector LIB "fgw32.dll" ALIAS "_fg_3Dupvector@24" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE)
DECLARE SUB      fg_3Dviewport LIB "fgw32.dll" ALIAS "_fg_3Dviewport@24" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS DOUBLE)
DECLARE FUNCTION fg_3Dzclip LIB "fgw32.dll" ALIAS "_fg_3Dzclip@12" _
                    (Arg1 AS DOUBLE, Arg2 AS DOUBLE, BYVAL Arg3 AS LONG) AS LONG
DECLARE FUNCTION fg_3Dzcliprgb LIB "fgw32.dll" ALIAS "_fg_3Dzcliprgb@20" _
                    (Arg1 AS DOUBLE, Arg2 AS DOUBLE, Arg3 AS BYTE, Arg4 AS BYTE, BYVAL Arg5 AS LONG) AS LONG
DECLARE FUNCTION fg_3Dzcliptm LIB "fgw32.dll" ALIAS "_fg_3Dzcliptm@20" _
                    (Arg1 AS DOUBLE, Arg2 AS DOUBLE, Arg3 AS ANY, Arg4 AS ANY, BYVAL Arg5 AS LONG) AS LONG

DECLARE SUB      fg_arc LIB "fgw32.dll" ALIAS "_fg_arc@12" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_arcw LIB "fgw32.dll" ALIAS "_fg_arcw@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_avidone LIB "fgw32.dll" ALIAS "_fg_avidone@4" _
                    (Arg1 AS ANY)
DECLARE FUNCTION fg_aviframe LIB "fgw32.dll" ALIAS "_fg_aviframe@8" _
                    (Arg1 AS ANY, Arg2 AS ANY) AS LONG
DECLARE FUNCTION fg_avihead LIB "fgw32.dll" ALIAS "_fg_avihead@8" _
                    (BYVAL Arg1 AS STRING, Arg2 AS ANY) AS LONG
DECLARE FUNCTION fg_avimake LIB "fgw32.dll" ALIAS "_fg_avimake@32" _
                    (BYVAL Arg1 AS STRING, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG, BYVAL Arg8 AS LONG) AS LONG
DECLARE FUNCTION fg_aviopen LIB "fgw32.dll" ALIAS "_fg_aviopen@8" _
                    (BYVAL Arg1 AS STRING, Arg2 AS ANY) AS LONG
DECLARE FUNCTION fg_avipal LIB "fgw32.dll" ALIAS "_fg_avipal@8" _
                    (BYVAL Arg1 AS STRING, Arg2 AS ANY) AS LONG
DECLARE FUNCTION fg_aviplay LIB "fgw32.dll" ALIAS "_fg_aviplay@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG) AS LONG
DECLARE SUB      fg_avisize LIB "fgw32.dll" ALIAS "_fg_avisize@12" _
                    (Arg1 AS ANY, Arg2 AS LONG, Arg3 AS LONG)
DECLARE FUNCTION fg_aviskip LIB "fgw32.dll" ALIAS "_fg_aviskip@8" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG) AS LONG

DECLARE FUNCTION fg_blend LIB "fgw32.dll" ALIAS "_fg_blend@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG) AS LONG
DECLARE FUNCTION fg_blend50 LIB "fgw32.dll" ALIAS "_fg_blend50@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG) AS LONG
DECLARE SUB      fg_blenddcb LIB "fgw32.dll" ALIAS "_fg_blenddcb@16" _
                    (Arg1 AS ANY, Arg2 AS ANY, Arg3 AS ANY, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_blendvar LIB "fgw32.dll" ALIAS "_fg_blendvar@20" _
                    (Arg1 AS ANY, Arg2 AS ANY, Arg3 AS ANY, Arg4 AS ANY, BYVAL Arg5 AS LONG)
DECLARE SUB      fg_blendvb LIB "fgw32.dll" ALIAS "_fg_blendvb@16" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_blendvbv LIB "fgw32.dll" ALIAS "_fg_blendvbv@20" _
                    (Arg1 AS ANY, Arg2 AS ANY, Arg3 AS ANY, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG)
DECLARE FUNCTION fg_bmphead LIB "fgw32.dll" ALIAS "_fg_bmphead@8" _
                    (BYVAL Arg1 AS STRING, Arg2 AS ANY) AS LONG
DECLARE FUNCTION fg_bmppal LIB "fgw32.dll" ALIAS "_fg_bmppal@8" _
                    (BYVAL Arg1 AS STRING, Arg2 AS ANY) AS LONG
DECLARE SUB      fg_bmpsize LIB "fgw32.dll" ALIAS "_fg_bmpsize@12" _
                    (Arg1 AS ANY, Arg2 AS LONG, Arg3 AS LONG)
DECLARE SUB      fg_box LIB "fgw32.dll" ALIAS "_fg_box@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_boxdepth LIB "fgw32.dll" ALIAS "_fg_boxdepth@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_boxw LIB "fgw32.dll" ALIAS "_fg_boxw@32" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE)
DECLARE SUB      fg_boxx LIB "fgw32.dll" ALIAS "_fg_boxx@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_boxxw LIB "fgw32.dll" ALIAS "_fg_boxxw@32" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE)

DECLARE SUB      fg_circle LIB "fgw32.dll" ALIAS "_fg_circle@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_circlef LIB "fgw32.dll" ALIAS "_fg_circlef@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_circlefw LIB "fgw32.dll" ALIAS "_fg_circlefw@8" _
                    (BYVAL Arg1 AS DOUBLE)
DECLARE SUB      fg_circlew LIB "fgw32.dll" ALIAS "_fg_circlew@8" _
                    (BYVAL Arg1 AS DOUBLE)
DECLARE FUNCTION fg_clip2vb LIB "fgw32.dll" ALIAS "_fg_clip2vb@20" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG) AS LONG
DECLARE SUB      fg_clipdcb LIB "fgw32.dll" ALIAS "_fg_clipdcb@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_clipmap LIB "fgw32.dll" ALIAS "_fg_clipmap@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_clipmask LIB "fgw32.dll" ALIAS "_fg_clipmask@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_clpimage LIB "fgw32.dll" ALIAS "_fg_clpimage@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_clprect LIB "fgw32.dll" ALIAS "_fg_clprect@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_clprectw LIB "fgw32.dll" ALIAS "_fg_clprectw@32" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE)
DECLARE SUB      fg_clprectx LIB "fgw32.dll" ALIAS "_fg_clprectx@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE FUNCTION fg_colors LIB "fgw32.dll" ALIAS "_fg_colors@0" _
                    () AS LONG
DECLARE SUB      fg_contdcb LIB "fgw32.dll" ALIAS "_fg_contdcb@20" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG)
DECLARE SUB      fg_contrgb LIB "fgw32.dll" ALIAS "_fg_contrgb@16" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_contvb LIB "fgw32.dll" ALIAS "_fg_contvb@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_copypage LIB "fgw32.dll" ALIAS "_fg_copypage@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_cut LIB "fgw32.dll" ALIAS "_fg_cut@28" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG)
DECLARE SUB      fg_cutdcb LIB "fgw32.dll" ALIAS "_fg_cutdcb@28" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG)

DECLARE SUB      fg_dash LIB "fgw32.dll" ALIAS "_fg_dash@12" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_dashrel LIB "fgw32.dll" ALIAS "_fg_dashrel@12" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_dashrw LIB "fgw32.dll" ALIAS "_fg_dashrw@20" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_dashw LIB "fgw32.dll" ALIAS "_fg_dashw@20" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_defcolor LIB "fgw32.dll" ALIAS "_fg_defcolor@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE FUNCTION fg_defpal LIB "fgw32.dll" ALIAS "_fg_defpal@0" _
                    () AS LONG
DECLARE SUB      fg_dispfile LIB "fgw32.dll" ALIAS "_fg_dispfile@12" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_display LIB "fgw32.dll" ALIAS "_fg_display@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_displayp LIB "fgw32.dll" ALIAS "_fg_displayp@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_draw LIB "fgw32.dll" ALIAS "_fg_draw@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_drawdcb LIB "fgw32.dll" ALIAS "_fg_drawdcb@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_drawmap LIB "fgw32.dll" ALIAS "_fg_drawmap@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_drawmask LIB "fgw32.dll" ALIAS "_fg_drawmask@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_drawrel LIB "fgw32.dll" ALIAS "_fg_drawrel@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_drawrelx LIB "fgw32.dll" ALIAS "_fg_drawrelx@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_drawrw LIB "fgw32.dll" ALIAS "_fg_drawrw@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_drawrxw LIB "fgw32.dll" ALIAS "_fg_drawrxw@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_draww LIB "fgw32.dll" ALIAS "_fg_draww@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_drawx LIB "fgw32.dll" ALIAS "_fg_drawx@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_drawxw LIB "fgw32.dll" ALIAS "_fg_drawxw@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_drawz LIB "fgw32.dll" ALIAS "_fg_drawz@24" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE)
DECLARE SUB      fg_drect LIB "fgw32.dll" ALIAS "_fg_drect@20" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, Arg5 AS ANY)
DECLARE SUB      fg_drectw LIB "fgw32.dll" ALIAS "_fg_drectw@36" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE, Arg5 AS ANY)
DECLARE SUB      fg_drwimage LIB "fgw32.dll" ALIAS "_fg_drwimage@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)

DECLARE SUB      fg_ellipse LIB "fgw32.dll" ALIAS "_fg_ellipse@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_ellipsef LIB "fgw32.dll" ALIAS "_fg_ellipsef@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_ellipsew LIB "fgw32.dll" ALIAS "_fg_ellipsew@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_ellipsfw LIB "fgw32.dll" ALIAS "_fg_ellipsfw@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_erase LIB "fgw32.dll" ALIAS "_fg_erase@0" _
                    ()

DECLARE SUB      fg_fillpage LIB "fgw32.dll" ALIAS "_fg_fillpage@0" _
                    ()
DECLARE FUNCTION fg_findrgb LIB "fgw32.dll" ALIAS "_fg_findrgb@12" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG) AS LONG
DECLARE FUNCTION fg_fixdiv LIB "fgw32.dll" ALIAS "_fg_fixdiv@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG) AS LONG
DECLARE FUNCTION fg_fixed LIB "fgw32.dll" ALIAS "_fg_fixed@8" _
                    (BYVAL Arg1 AS DOUBLE) AS LONG
DECLARE FUNCTION fg_fixmul LIB "fgw32.dll" ALIAS "_fg_fixmul@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG) AS LONG
DECLARE SUB      fg_fixtrig LIB "fgw32.dll" ALIAS "_fg_fixtrig@12" _
                    (BYVAL Arg1 AS LONG, Arg2 AS LONG, Arg3 AS LONG)
DECLARE SUB      fg_flicdone LIB "fgw32.dll" ALIAS "_fg_flicdone@4" _
                    (Arg1 AS ANY)
DECLARE FUNCTION fg_flichead LIB "fgw32.dll" ALIAS "_fg_flichead@8" _
                    (BYVAL Arg1 AS STRING, Arg2 AS ANY) AS LONG
DECLARE FUNCTION fg_flicopen LIB "fgw32.dll" ALIAS "_fg_flicopen@8" _
                    (BYVAL Arg1 AS STRING, Arg2 AS ANY) AS LONG
DECLARE FUNCTION fg_flicplay LIB "fgw32.dll" ALIAS "_fg_flicplay@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG) AS LONG
DECLARE SUB      fg_flicsize LIB "fgw32.dll" ALIAS "_fg_flicsize@12" _
                    (Arg1 AS ANY, Arg2 AS LONG, Arg3 AS LONG)
DECLARE FUNCTION fg_flicskip LIB "fgw32.dll" ALIAS "_fg_flicskip@8" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG) AS LONG
DECLARE SUB      fg_flipdcb LIB "fgw32.dll" ALIAS "_fg_flipdcb@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_flipmask LIB "fgw32.dll" ALIAS "_fg_flipmask@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE FUNCTION fg_float LIB "fgw32.dll" ALIAS "_fg_float@4" _
                    (BYVAL Arg1 AS LONG) AS DOUBLE
DECLARE SUB      fg_flood LIB "fgw32.dll" ALIAS "_fg_flood@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_floodw LIB "fgw32.dll" ALIAS "_fg_floodw@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_flpimage LIB "fgw32.dll" ALIAS "_fg_flpimage@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_fontdc LIB "fgw32.dll" ALIAS "_fg_fontdc@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_fontload LIB "fgw32.dll" ALIAS "_fg_fontload@4" _
                    (BYVAL Arg1 AS LONG)

DECLARE SUB      fg_gammadcb LIB "fgw32.dll" ALIAS "_fg_gammadcb@20" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_gammargb LIB "fgw32.dll" ALIAS "_fg_gammargb@16" _
                    (Arg1 AS ANY, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_gammavb LIB "fgw32.dll" ALIAS "_fg_gammavb@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_getblock LIB "fgw32.dll" ALIAS "_fg_getblock@20" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG)
DECLARE SUB      fg_getclip LIB "fgw32.dll" ALIAS "_fg_getclip@16" _
                    (Arg1 AS LONG, Arg2 AS LONG, Arg3 AS LONG, Arg4 AS LONG)
DECLARE FUNCTION fg_getclock LIB "fgw32.dll" ALIAS "_fg_getclock@0" _
                    () AS LONG
DECLARE FUNCTION fg_getcolor LIB "fgw32.dll" ALIAS "_fg_getcolor@0" _
                    () AS LONG
DECLARE SUB      fg_getdacs LIB "fgw32.dll" ALIAS "_fg_getdacs@12" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, Arg3 AS ANY)
DECLARE FUNCTION fg_getdc LIB "fgw32.dll" ALIAS "_fg_getdc@0" _
                    () AS LONG
DECLARE SUB      fg_getdcb LIB "fgw32.dll" ALIAS "_fg_getdcb@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE FUNCTION fg_getdepth LIB "fgw32.dll" ALIAS "_fg_getdepth@0" _
                    () AS LONG
DECLARE FUNCTION fg_gethcbpp LIB "fgw32.dll" ALIAS "_fg_gethcbpp@0" _
                    () AS LONG
DECLARE FUNCTION fg_gethpage LIB "fgw32.dll" ALIAS "_fg_gethpage@0" _
                    () AS LONG
DECLARE SUB      fg_getimage LIB "fgw32.dll" ALIAS "_fg_getimage@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE FUNCTION fg_getindex LIB "fgw32.dll" ALIAS "_fg_getindex@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_getline LIB "fgw32.dll" ALIAS "_fg_getline@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_getlines LIB "fgw32.dll" ALIAS "_fg_getlines@0" _
                    () AS LONG
DECLARE SUB      fg_getmap LIB "fgw32.dll" ALIAS "_fg_getmap@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE FUNCTION fg_getmaxx LIB "fgw32.dll" ALIAS "_fg_getmaxx@0" _
                    () AS LONG
DECLARE FUNCTION fg_getmaxy LIB "fgw32.dll" ALIAS "_fg_getmaxy@0" _
                    () AS LONG
DECLARE FUNCTION fg_getpage LIB "fgw32.dll" ALIAS "_fg_getpage@0" _
                    () AS LONG
DECLARE FUNCTION fg_getpixel LIB "fgw32.dll" ALIAS "_fg_getpixel@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG) AS LONG
DECLARE SUB      fg_getrgb LIB "fgw32.dll" ALIAS "_fg_getrgb@16" _
                    (BYVAL Arg1 AS LONG, Arg2 AS LONG, Arg3 AS LONG, Arg4 AS LONG)
DECLARE SUB      fg_getview LIB "fgw32.dll" ALIAS "_fg_getview@32" _
                    (Arg1 AS LONG, Arg2 AS LONG, Arg3 AS LONG, Arg4 AS LONG, Arg5 AS LONG, Arg6 AS LONG, Arg7 AS LONG, Arg8 AS LONG)
DECLARE SUB      fg_getworld LIB "fgw32.dll" ALIAS "_fg_getworld@16" _
                    (Arg1 AS DOUBLE, Arg2 AS DOUBLE, Arg3 AS DOUBLE, Arg4 AS DOUBLE)
DECLARE FUNCTION fg_getxbox LIB "fgw32.dll" ALIAS "_fg_getxbox@0" _
                    () AS LONG
DECLARE FUNCTION fg_getxjust LIB "fgw32.dll" ALIAS "_fg_getxjust@0" _
                    () AS LONG
DECLARE FUNCTION fg_getxpos LIB "fgw32.dll" ALIAS "_fg_getxpos@0" _
                    () AS LONG
DECLARE FUNCTION fg_getybox LIB "fgw32.dll" ALIAS "_fg_getybox@0" _
                    () AS LONG
DECLARE FUNCTION fg_getyjust LIB "fgw32.dll" ALIAS "_fg_getyjust@0" _
                    () AS LONG
DECLARE FUNCTION fg_getypos LIB "fgw32.dll" ALIAS "_fg_getypos@0" _
                    () AS LONG
DECLARE SUB      fg_gouraud LIB "fgw32.dll" ALIAS "_fg_gouraud@12" _
                    (Arg1 AS LONG, Arg2 AS BYTE, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_gouraudz LIB "fgw32.dll" ALIAS "_fg_gouraudz@16" _
                    (Arg1 AS LONG, Arg2 AS BYTE, Arg3 AS DOUBLE, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_graydcb LIB "fgw32.dll" ALIAS "_fg_graydcb@12" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_grayrgb LIB "fgw32.dll" ALIAS "_fg_grayrgb@8" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_grayvb LIB "fgw32.dll" ALIAS "_fg_grayvb@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)

DECLARE SUB      fg_imagebuf LIB "fgw32.dll" ALIAS "_fg_imagebuf@8" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG)
DECLARE FUNCTION fg_imagesiz LIB "fgw32.dll" ALIAS "_fg_imagesiz@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG) AS LONG
DECLARE SUB      fg_initw LIB "fgw32.dll" ALIAS "_fg_initw@0" _
                    ()
DECLARE FUNCTION fg_inside LIB "fgw32.dll" ALIAS "_fg_inside@16" _
                    (Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG) AS LONG
DECLARE SUB      fg_invdcb LIB "fgw32.dll" ALIAS "_fg_invdcb@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_invert LIB "fgw32.dll" ALIAS "_fg_invert@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)

DECLARE SUB      fg_jpegbuf LIB "fgw32.dll" ALIAS "_fg_jpegbuf@8" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG)
DECLARE FUNCTION fg_jpeghead LIB "fgw32.dll" ALIAS "_fg_jpeghead@8" _
                    (BYVAL Arg1 AS STRING, Arg2 AS ANY) AS LONG
DECLARE FUNCTION fg_jpegmem LIB "fgw32.dll" ALIAS "_fg_jpegmem@4" _
                    (Arg1 AS ANY) AS LONG
DECLARE SUB      fg_jpegsize LIB "fgw32.dll" ALIAS "_fg_jpegsize@12" _
                    (Arg1 AS ANY, Arg2 AS LONG, Arg3 AS LONG)
DECLARE SUB      fg_justify LIB "fgw32.dll" ALIAS "_fg_justify@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)

DECLARE FUNCTION fg_kbtest LIB "fgw32.dll" ALIAS "_fg_kbtest@4" _
                    (BYVAL Arg1 AS LONG) AS LONG

DECLARE FUNCTION fg_loadpcx LIB "fgw32.dll" ALIAS "_fg_loadpcx@8" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG) AS LONG
DECLARE SUB      fg_locate LIB "fgw32.dll" ALIAS "_fg_locate@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_logfont LIB "fgw32.dll" ALIAS "_fg_logfont@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE FUNCTION fg_logpal LIB "fgw32.dll" ALIAS "_fg_logpal@12" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, Arg3 AS ANY) AS LONG

DECLARE FUNCTION fg_makebmp LIB "fgw32.dll" ALIAS "_fg_makebmp@24" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS STRING) AS LONG
DECLARE FUNCTION fg_makepcx LIB "fgw32.dll" ALIAS "_fg_makepcx@20" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS STRING) AS LONG
DECLARE FUNCTION fg_makeppr LIB "fgw32.dll" ALIAS "_fg_makeppr@20" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS STRING) AS LONG
DECLARE FUNCTION fg_makespr LIB "fgw32.dll" ALIAS "_fg_makespr@20" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS STRING) AS LONG
DECLARE SUB      fg_mapdacs LIB "fgw32.dll" ALIAS "_fg_mapdacs@12" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG)
DECLARE FUNCTION fg_maprgb LIB "fgw32.dll" ALIAS "_fg_maprgb@12" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG) AS LONG
DECLARE FUNCTION fg_measure LIB "fgw32.dll" ALIAS "_fg_measure@0" _
                    () AS LONG
DECLARE FUNCTION fg_memavail LIB "fgw32.dll" ALIAS "_fg_memavail@0" _
                    () AS LONG
DECLARE FUNCTION fg_modeset LIB "fgw32.dll" ALIAS "_fg_modeset@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG) AS LONG
DECLARE FUNCTION fg_modetest LIB "fgw32.dll" ALIAS "_fg_modetest@12" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG) AS LONG
DECLARE SUB      fg_mousecur LIB "fgw32.dll" ALIAS "_fg_mousecur@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE FUNCTION fg_mouseini LIB "fgw32.dll" ALIAS "_fg_mouseini@0" _
                    () AS LONG
DECLARE SUB      fg_mouselim LIB "fgw32.dll" ALIAS "_fg_mouselim@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_mousemov LIB "fgw32.dll" ALIAS "_fg_mousemov@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_mousepos LIB "fgw32.dll" ALIAS "_fg_mousepos@8" _
                    (Arg1 AS LONG, Arg2 AS LONG)
DECLARE FUNCTION fg_mouseptr LIB "fgw32.dll" ALIAS "_fg_mouseptr@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG) AS LONG
DECLARE SUB      fg_mousesiz LIB "fgw32.dll" ALIAS "_fg_mousesiz@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_mousevis LIB "fgw32.dll" ALIAS "_fg_mousevis@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_move LIB "fgw32.dll" ALIAS "_fg_move@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_move3d LIB "fgw32.dll" ALIAS "_fg_move3d@20" _
                    (Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG)
DECLARE SUB      fg_moverel LIB "fgw32.dll" ALIAS "_fg_moverel@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_moverw LIB "fgw32.dll" ALIAS "_fg_moverw@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_movew LIB "fgw32.dll" ALIAS "_fg_movew@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)

DECLARE SUB      fg_opacity LIB "fgw32.dll" ALIAS "_fg_opacity@4" _
                    (BYVAL Arg1 AS LONG)

DECLARE SUB      fg_pack LIB "fgw32.dll" ALIAS "_fg_pack@16" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE FUNCTION fg_pagesize LIB "fgw32.dll" ALIAS "_fg_pagesize@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG) AS LONG
DECLARE SUB      fg_paint LIB "fgw32.dll" ALIAS "_fg_paint@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_paintw LIB "fgw32.dll" ALIAS "_fg_paintw@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_paste LIB "fgw32.dll" ALIAS "_fg_paste@28" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG)
DECLARE SUB      fg_pastedcb LIB "fgw32.dll" ALIAS "_fg_pastedcb@28" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG)
DECLARE FUNCTION fg_pcxhead LIB "fgw32.dll" ALIAS "_fg_pcxhead@8" _
                    (BYVAL Arg1 AS STRING, Arg2 AS ANY) AS LONG
DECLARE FUNCTION fg_pcxpal LIB "fgw32.dll" ALIAS "_fg_pcxpal@8" _
                    (BYVAL Arg1 AS STRING, Arg2 AS ANY) AS LONG
DECLARE SUB      fg_pcxrange LIB "fgw32.dll" ALIAS "_fg_pcxrange@20" _
                    (Arg1 AS ANY, Arg2 AS LONG, Arg3 AS LONG, Arg4 AS LONG, Arg5 AS LONG)
DECLARE SUB      fg_pcxsize LIB "fgw32.dll" ALIAS "_fg_pcxsize@12" _
                    (Arg1 AS ANY, Arg2 AS LONG, Arg3 AS LONG)
DECLARE SUB      fg_photodcb LIB "fgw32.dll" ALIAS "_fg_photodcb@12" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_photorgb LIB "fgw32.dll" ALIAS "_fg_photorgb@8" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_photovb LIB "fgw32.dll" ALIAS "_fg_photovb@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_point LIB "fgw32.dll" ALIAS "_fg_point@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_pointw LIB "fgw32.dll" ALIAS "_fg_pointw@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_pointx LIB "fgw32.dll" ALIAS "_fg_pointx@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_pointxw LIB "fgw32.dll" ALIAS "_fg_pointxw@16" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE)
DECLARE SUB      fg_polyedge LIB "fgw32.dll" ALIAS "_fg_polyedge@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_polyfill LIB "fgw32.dll" ALIAS "_fg_polyfill@12" _
                    (Arg1 AS LONG, Arg2 AS ANY, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_polyfilz LIB "fgw32.dll" ALIAS "_fg_polyfilz@12" _
                    (Arg1 AS LONG, Arg2 AS DOUBLE, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_polygon LIB "fgw32.dll" ALIAS "_fg_polygon@12" _
                    (Arg1 AS LONG, Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_polygonw LIB "fgw32.dll" ALIAS "_fg_polygonw@12" _
                    (Arg1 AS DOUBLE, Arg2 AS DOUBLE, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_polyline LIB "fgw32.dll" ALIAS "_fg_polyline@8" _
                    (Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_polyoff LIB "fgw32.dll" ALIAS "_fg_polyoff@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_print LIB "fgw32.dll" ALIAS "_fg_print@8" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG)
DECLARE FUNCTION fg_printdc LIB "fgw32.dll" ALIAS "_fg_printdc@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_printer LIB "fgw32.dll" ALIAS "_fg_printer@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE SUB      fg_project LIB "fgw32.dll" ALIAS "_fg_project@16" _
                    (Arg1 AS LONG, Arg2 AS LONG, Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_putblock LIB "fgw32.dll" ALIAS "_fg_putblock@20" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG)
DECLARE SUB      fg_putdcb LIB "fgw32.dll" ALIAS "_fg_putdcb@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_putimage LIB "fgw32.dll" ALIAS "_fg_putimage@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_putpixel LIB "fgw32.dll" ALIAS "_fg_putpixel@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)

DECLARE SUB      fg_realize LIB "fgw32.dll" ALIAS "_fg_realize@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_rect LIB "fgw32.dll" ALIAS "_fg_rect@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_rectw LIB "fgw32.dll" ALIAS "_fg_rectw@32" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE)
DECLARE SUB      fg_rectx LIB "fgw32.dll" ALIAS "_fg_rectx@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_reduce LIB "fgw32.dll" ALIAS "_fg_reduce@12" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, Arg3 AS ANY)
DECLARE SUB      fg_restore LIB "fgw32.dll" ALIAS "_fg_restore@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_restorew LIB "fgw32.dll" ALIAS "_fg_restorew@32" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE)
DECLARE SUB      fg_revdcb LIB "fgw32.dll" ALIAS "_fg_revdcb@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_revimage LIB "fgw32.dll" ALIAS "_fg_revimage@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_revmask LIB "fgw32.dll" ALIAS "_fg_revmask@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_rotate LIB "fgw32.dll" ALIAS "_fg_rotate@20" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG)
DECLARE SUB      fg_rotate3d LIB "fgw32.dll" ALIAS "_fg_rotate3d@20" _
                    (Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG)
DECLARE SUB      fg_rotdcb LIB "fgw32.dll" ALIAS "_fg_rotdcb@20" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG)
DECLARE SUB      fg_rotsize LIB "fgw32.dll" ALIAS "_fg_rotsize@20" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, Arg4 AS LONG, Arg5 AS LONG)

DECLARE SUB      fg_save LIB "fgw32.dll" ALIAS "_fg_save@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_savew LIB "fgw32.dll" ALIAS "_fg_savew@32" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE)
DECLARE SUB      fg_scale LIB "fgw32.dll" ALIAS "_fg_scale@24" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG)
DECLARE SUB      fg_scaledcb LIB "fgw32.dll" ALIAS "_fg_scaledcb@24" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG)
DECLARE SUB      fg_scroll LIB "fgw32.dll" ALIAS "_fg_scroll@24" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG)
DECLARE SUB      fg_setalpha LIB "fgw32.dll" ALIAS "_fg_setalpha@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_setangle LIB "fgw32.dll" ALIAS "_fg_setangle@8" _
                    (BYVAL Arg1 AS DOUBLE)
DECLARE SUB      fg_setclip LIB "fgw32.dll" ALIAS "_fg_setclip@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_setclipw LIB "fgw32.dll" ALIAS "_fg_setclipw@32" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE)
DECLARE SUB      fg_setcolor LIB "fgw32.dll" ALIAS "_fg_setcolor@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_setcolorrgb LIB "fgw32.dll" ALIAS "_fg_setcolorrgb@12" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_setdacs LIB "fgw32.dll" ALIAS "_fg_setdacs@12" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, Arg3 AS ANY)
DECLARE SUB      fg_setdc LIB "fgw32.dll" ALIAS "_fg_setdc@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_sethpage LIB "fgw32.dll" ALIAS "_fg_sethpage@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_setpage LIB "fgw32.dll" ALIAS "_fg_setpage@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_setratio LIB "fgw32.dll" ALIAS "_fg_setratio@8" _
                    (BYVAL Arg1 AS DOUBLE)
DECLARE SUB      fg_setrgb LIB "fgw32.dll" ALIAS "_fg_setrgb@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_setsize LIB "fgw32.dll" ALIAS "_fg_setsize@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_setsizew LIB "fgw32.dll" ALIAS "_fg_setsizew@8" _
                    (BYVAL Arg1 AS DOUBLE)
DECLARE SUB      fg_setview LIB "fgw32.dll" ALIAS "_fg_setview@32" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG, BYVAL Arg8 AS LONG)
DECLARE SUB      fg_setworld LIB "fgw32.dll" ALIAS "_fg_setworld@32" _
                    (BYVAL Arg1 AS DOUBLE, BYVAL Arg2 AS DOUBLE, BYVAL Arg3 AS DOUBLE, BYVAL Arg4 AS DOUBLE)
DECLARE SUB      fg_shear LIB "fgw32.dll" ALIAS "_fg_shear@24" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG)
DECLARE SUB      fg_sheardcb LIB "fgw32.dll" ALIAS "_fg_sheardcb@24" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG)
DECLARE FUNCTION fg_showavi LIB "fgw32.dll" ALIAS "_fg_showavi@12" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG) AS LONG
DECLARE FUNCTION fg_showbmp LIB "fgw32.dll" ALIAS "_fg_showbmp@8" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG) AS LONG
DECLARE FUNCTION fg_showflic LIB "fgw32.dll" ALIAS "_fg_showflic@12" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG) AS LONG
DECLARE FUNCTION fg_showjpeg LIB "fgw32.dll" ALIAS "_fg_showjpeg@8" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG) AS LONG
DECLARE FUNCTION fg_showpcx LIB "fgw32.dll" ALIAS "_fg_showpcx@8" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG) AS LONG
DECLARE FUNCTION fg_showppr LIB "fgw32.dll" ALIAS "_fg_showppr@8" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG) AS LONG
DECLARE FUNCTION fg_showspr LIB "fgw32.dll" ALIAS "_fg_showspr@8" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG) AS LONG
DECLARE SUB      fg_stall LIB "fgw32.dll" ALIAS "_fg_stall@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_swchar LIB "fgw32.dll" ALIAS "_fg_swchar@12" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)
DECLARE FUNCTION fg_swlength LIB "fgw32.dll" ALIAS "_fg_swlength@8" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG) AS DOUBLE
DECLARE SUB      fg_swtext LIB "fgw32.dll" ALIAS "_fg_swtext@12" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG)

DECLARE SUB      fg_tcdefine LIB "fgw32.dll" ALIAS "_fg_tcdefine@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_tcmask LIB "fgw32.dll" ALIAS "_fg_tcmask@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_tcxfer LIB "fgw32.dll" ALIAS "_fg_tcxfer@32" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG, BYVAL Arg8 AS LONG)
DECLARE SUB      fg_texmap LIB "fgw32.dll" ALIAS "_fg_texmap@12" _
                    (Arg1 AS LONG, Arg2 AS ANY, BYVAL Arg3 AS LONG)
DECLARE SUB      fg_texmapp LIB "fgw32.dll" ALIAS "_fg_texmapp@16" _
                    (Arg1 AS LONG, Arg2 AS ANY, Arg3 AS DOUBLE, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_texmappz LIB "fgw32.dll" ALIAS "_fg_texmappz@16" _
                    (Arg1 AS LONG, Arg2 AS ANY, Arg3 AS DOUBLE, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_texmapz LIB "fgw32.dll" ALIAS "_fg_texmapz@16" _
                    (Arg1 AS LONG, Arg2 AS ANY, Arg3 AS DOUBLE, BYVAL Arg4 AS LONG)
DECLARE SUB      fg_text LIB "fgw32.dll" ALIAS "_fg_text@8" _
                    (BYVAL Arg1 AS STRING, BYVAL Arg2 AS LONG)
DECLARE SUB      fg_texture LIB "fgw32.dll" ALIAS "_fg_texture@8" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG)
DECLARE FUNCTION fg_tmdefine LIB "fgw32.dll" ALIAS "_fg_tmdefine@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG) AS LONG
DECLARE SUB      fg_tmevict LIB "fgw32.dll" ALIAS "_fg_tmevict@0" _
                    ()
DECLARE SUB      fg_tmfree LIB "fgw32.dll" ALIAS "_fg_tmfree@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE FUNCTION fg_tminit LIB "fgw32.dll" ALIAS "_fg_tminit@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE SUB      fg_tmselect LIB "fgw32.dll" ALIAS "_fg_tmselect@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_tmspan LIB "fgw32.dll" ALIAS "_fg_tmspan@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_tmtransparency LIB "fgw32.dll" ALIAS "_fg_tmtransparency@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_tmunits LIB "fgw32.dll" ALIAS "_fg_tmunits@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_transdcb LIB "fgw32.dll" ALIAS "_fg_transdcb@20" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG)
DECLARE SUB      fg_transfer LIB "fgw32.dll" ALIAS "_fg_transfer@32" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG, BYVAL Arg8 AS LONG)
DECLARE SUB      fg_trig LIB "fgw32.dll" ALIAS "_fg_trig@12" _
                    (BYVAL Arg1 AS LONG, Arg2 AS DOUBLE, Arg3 AS DOUBLE)

DECLARE SUB      fg_unmaprgb LIB "fgw32.dll" ALIAS "_fg_unmaprgb@16" _
                    (BYVAL Arg1 AS LONG, Arg2 AS LONG, Arg3 AS LONG, Arg4 AS LONG)
DECLARE SUB      fg_unpack LIB "fgw32.dll" ALIAS "_fg_unpack@12" _
                    (Arg1 AS ANY, Arg2 AS ANY, BYVAL Arg3 AS LONG)

DECLARE FUNCTION fg_vb2clip LIB "fgw32.dll" ALIAS "_fg_vb2clip@16" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG) AS LONG
DECLARE FUNCTION fg_vbaddr LIB "fgw32.dll" ALIAS "_fg_vbaddr@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_vballoc LIB "fgw32.dll" ALIAS "_fg_vballoc@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG) AS LONG
DECLARE SUB      fg_vbclose LIB "fgw32.dll" ALIAS "_fg_vbclose@0" _
                    ()
DECLARE SUB      fg_vbcolors LIB "fgw32.dll" ALIAS "_fg_vbcolors@0" _
                    ()
DECLARE SUB      fg_vbcopy LIB "fgw32.dll" ALIAS "_fg_vbcopy@32" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG, BYVAL Arg8 AS LONG)
DECLARE FUNCTION fg_vbdefine LIB "fgw32.dll" ALIAS "_fg_vbdefine@12" _
                    (Arg1 AS ANY, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG) AS LONG
DECLARE SUB      fg_vbdepth LIB "fgw32.dll" ALIAS "_fg_vbdepth@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_vbfin LIB "fgw32.dll" ALIAS "_fg_vbfin@0" _
                    ()
DECLARE SUB      fg_vbfree LIB "fgw32.dll" ALIAS "_fg_vbfree@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE FUNCTION fg_vbhandle LIB "fgw32.dll" ALIAS "_fg_vbhandle@0" _
                    () AS LONG
DECLARE FUNCTION fg_vbinit LIB "fgw32.dll" ALIAS "_fg_vbinit@0" _
                    () AS LONG
DECLARE FUNCTION fg_vbopen LIB "fgw32.dll" ALIAS "_fg_vbopen@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE SUB      fg_vbpaste LIB "fgw32.dll" ALIAS "_fg_vbpaste@24" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG)
DECLARE SUB      fg_vbprint LIB "fgw32.dll" ALIAS "_fg_vbprint@36" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG, BYVAL Arg8 AS LONG, BYVAL Arg9 AS LONG)
DECLARE SUB      fg_vbscale LIB "fgw32.dll" ALIAS "_fg_vbscale@32" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG, BYVAL Arg8 AS LONG)
DECLARE FUNCTION fg_vbsize LIB "fgw32.dll" ALIAS "_fg_vbsize@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG) AS LONG
DECLARE SUB      fg_vbtccopy LIB "fgw32.dll" ALIAS "_fg_vbtccopy@32" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG, BYVAL Arg8 AS LONG)
DECLARE SUB      fg_vbtcopy LIB "fgw32.dll" ALIAS "_fg_vbtcopy@36" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG, BYVAL Arg8 AS LONG, BYVAL Arg9 AS LONG)
DECLARE SUB      fg_vbtzcopy LIB "fgw32.dll" ALIAS "_fg_vbtzcopy@32" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG, BYVAL Arg6 AS LONG, BYVAL Arg7 AS LONG, BYVAL Arg8 AS LONG)
DECLARE SUB      fg_vbundef LIB "fgw32.dll" ALIAS "_fg_vbundef@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_version LIB "fgw32.dll" ALIAS "_fg_version@8" _
                    (Arg1 AS LONG, Arg2 AS LONG)
DECLARE SUB      fg_view3d LIB "fgw32.dll" ALIAS "_fg_view3d@20" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG, BYVAL Arg3 AS LONG, BYVAL Arg4 AS LONG, BYVAL Arg5 AS LONG)

DECLARE SUB      fg_waitfor LIB "fgw32.dll" ALIAS "_fg_waitfor@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_where LIB "fgw32.dll" ALIAS "_fg_where@8" _
                    (Arg1 AS LONG, Arg2 AS LONG)

DECLARE FUNCTION fg_xalpha LIB "fgw32.dll" ALIAS "_fg_xalpha@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_xclient LIB "fgw32.dll" ALIAS "_fg_xclient@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_xconvert LIB "fgw32.dll" ALIAS "_fg_xconvert@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_xscreen LIB "fgw32.dll" ALIAS "_fg_xscreen@8" _
                    (BYVAL Arg1 AS DOUBLE) AS LONG
DECLARE FUNCTION fg_xvb LIB "fgw32.dll" ALIAS "_fg_xvb@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_xview LIB "fgw32.dll" ALIAS "_fg_xview@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_xworld LIB "fgw32.dll" ALIAS "_fg_xworld@4" _
                    (BYVAL Arg1 AS LONG) AS DOUBLE

DECLARE FUNCTION fg_yalpha LIB "fgw32.dll" ALIAS "_fg_yalpha@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_yclient LIB "fgw32.dll" ALIAS "_fg_yclient@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_yconvert LIB "fgw32.dll" ALIAS "_fg_yconvert@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_yscreen LIB "fgw32.dll" ALIAS "_fg_yscreen@8" _
                    (BYVAL Arg1 AS DOUBLE) AS LONG
DECLARE FUNCTION fg_yvb LIB "fgw32.dll" ALIAS "_fg_yvb@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_yview LIB "fgw32.dll" ALIAS "_fg_yview@4" _
                    (BYVAL Arg1 AS LONG) AS LONG
DECLARE FUNCTION fg_yworld LIB "fgw32.dll" ALIAS "_fg_yworld@4" _
                    (BYVAL Arg1 AS LONG) AS DOUBLE

DECLARE FUNCTION fg_zballoc LIB "fgw32.dll" ALIAS "_fg_zballoc@8" _
                    (BYVAL Arg1 AS LONG, BYVAL Arg2 AS LONG) AS LONG
DECLARE SUB      fg_zbframe LIB "fgw32.dll" ALIAS "_fg_zbframe@0" _
                    ()
DECLARE SUB      fg_zbfree LIB "fgw32.dll" ALIAS "_fg_zbfree@4" _
                    (BYVAL Arg1 AS LONG)
DECLARE SUB      fg_zbopen LIB "fgw32.dll" ALIAS "_fg_zbopen@4" _
                    (BYVAL Arg1 AS LONG)

#ENDIF   ' of #IF NOT %DEF(%FGWIN_INC)
