'*****************************************************************************
'                                                                            *
'  Fade.vb                                                                   *
'                                                                            *
'  This program shows how perform a palette fade.                            *
'                                                                            *
'*****************************************************************************
Public Class Form1
    Inherits System.Windows.Forms.Form

    ' Fastgraph variables.
    Dim g As Graphics
    Dim hDC As IntPtr
    Dim hPal As Integer
    Dim hVB As Integer
    Dim cxClient, cyClient As Integer

    ' Virtual buffer dimensions.
    Const vbWidth As Integer = 320
    Const vbHeight As Integer = 200

    ' Holds original and current RGB palette values for 236 user colors.
    Dim Original(236 * 3) As Byte
    Dim Current(236 * 3) As Byte

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        g = Me.CreateGraphics

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        g.Dispose()
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents menuFadeIn As System.Windows.Forms.MenuItem
    Friend WithEvents menuFadeOut As System.Windows.Forms.MenuItem
    Friend WithEvents menuExit As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu()
        Me.menuFadeIn = New System.Windows.Forms.MenuItem()
        Me.menuFadeOut = New System.Windows.Forms.MenuItem()
        Me.menuExit = New System.Windows.Forms.MenuItem()
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuFadeIn, Me.menuFadeOut, Me.menuExit})
        '
        'menuFadeIn
        '
        Me.menuFadeIn.Enabled = False
        Me.menuFadeIn.Index = 0
        Me.menuFadeIn.Text = "Fade&In"
        '
        'menuFadeOut
        '
        Me.menuFadeOut.Index = 1
        Me.menuFadeOut.Text = "Fade&Out"
        '
        'menuExit
        '
        Me.menuExit.Index = 2
        Me.menuExit.Text = "E&xit"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(446, 276)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "Palette Fades"

    End Sub

#End Region

    Private Sub Form1_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Activated
        fg_realize(hPal)
        cxClient = ClientRectangle.Width
        cyClient = ClientRectangle.Height
        Refresh()
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        hDC = g.GetHdc()
        fg_setdc(hDC)
        hPal = fg_defpal()
        fg_realize(hPal)

        fg_vbinit()
        hVB = fg_vballoc(vbWidth, vbHeight)
        fg_vbopen(hVB)
        fg_vbcolors()

        fg_showpcx("MOUSE.PCX", FG_AT_XY)
        fg_getdacs(10, 236, Original(0))
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        cxClient = ClientRectangle.Width
        cyClient = ClientRectangle.Height
        fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
    End Sub

    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        fg_vbclose()
        fg_vbfree(hVB)
        fg_vbfin()
        g.ReleaseHdc(hDC)
    End Sub

    '*****************************************************************************
    '                                                                            *
    '  FadeIn_Click()                                                            *
    '                                                                            *
    '  Fade an image back to its original colors.                                *
    '                                                                            *
    '*****************************************************************************

    Private Sub menuFadeIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuFadeIn.Click
        Dim I As Integer
        Dim Fading As Boolean

        Me.Cursor = Cursors.WaitCursor
        Array.Clear(Current, 0, Current.Length)

        Do
            Fading = False
            For I = 0 To 236 * 3 - 1
                If Current(I) <> Original(I) Then
                    Current(I) += 1
                    Fading = True
                End If
            Next I
            fg_setdacs(10, 236, Current(0))
            If fg_colors() > 8 Then
                fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
            End If
        Loop While Fading

        menuFadeIn.Enabled = False
        menuFadeOut.Enabled = True
        Me.Cursor = Cursors.Default
    End Sub

    '*****************************************************************************
    '                                                                            *
    '  FadeOut_Click()                                                           *
    '                                                                            *
    '  Fade an image to black.                                                   *
    '                                                                            *
    '*****************************************************************************

    Private Sub menuFadeOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuFadeOut.Click
        Dim I As Integer
        Dim Fading As Boolean

        Me.Cursor = Cursors.WaitCursor
        Current = Original.Clone

        Do
            Fading = False
            For I = 0 To 236 * 3 - 1
                If Current(I) <> 0 Then
                    Current(I) -= 1
                    Fading = True
                End If
            Next I
            fg_setdacs(10, 236, Current(0))
            If fg_colors() > 8 Then
                fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
            End If
        Loop While Fading

        menuFadeOut.Enabled = False
        menuFadeIn.Enabled = True
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub menuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuExit.Click
        Me.Close()
    End Sub
End Class