VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   0  'None
   Caption         =   "DirectDraw Frame Animation"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   6690
   LinkTopic       =   "Form1"
   PaletteMode     =   2  'Custom
   ScaleHeight     =   4140
   ScaleWidth      =   6690
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'*****************************************************************************
'                                                                            *
'  FrameDD.frm                                                               *
'                                                                            *
'  This program shows how to set up a full screen DirectDraw application     *
'  for either blitting or flipping. The selection of blitting or flipping is *
'  controlled by the BLIT and FLIP symbols defined below.                    *
'                                                                            *
'  Requires Visual Basic 5.0 or later.                                       *
'                                                                            *
'*****************************************************************************

Const vbWidth = 640
Const vbHeight = 480

' define either Blit or Flip, but not both, for blitting or flipping
#Const Blit = True
#Const Flip = False

Dim hPal As Long
Dim hVB As Long
Dim AppIsActive As Boolean
Dim AppIsRunning As Boolean

Public Sub ActivateApp(ByVal wParam As Long)
   AppIsActive = (wParam <> 0)
   If AppIsActive Then
      WindowState = vbMaximized
      Call fg_ddrestore
   Else
      WindowState = vbMinimized
      #If Flip Then
      Call fg_gdiflip
      #End If
   End If
End Sub

Private Sub Form_Activate()
   Call fg_realize(hPal)
End Sub

Private Sub Form_Load()
   ScaleMode = 3
   #If Blit Then
   Call fg_ddsetup(vbWidth, vbHeight, 8, FG_DX_BLIT)
   #Else
   Call fg_ddsetup(vbWidth, vbHeight, 8, FG_DX_FLIP)
   #End If
   Call fg_setdc(hDC)
   hPal = fg_defpal()
   Call fg_realize(hPal)
   Visible = True

   ' if blitting, create a virtual buffer the same size as the screen
   ' resolution; if flipping, use the primary surface's back buffer
   Call fg_vbinit
   #If Blit Then
   hVB = fg_vballoc(vbWidth, vbHeight)
   #Else
   hVB = 0
   #End If
   Call fg_vbopen(hVB)
   Call fg_vbcolors

   Call fg_mouseini
   Call fg_mousevis(0)

   AppIsActive = True
   AppIsRunning = True
   Call HookWindowProc(hWnd)
   While AppIsRunning
      DoEvents
      If AppIsActive Then Call Animate
   Wend
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
   If KeyCode = vbKeyEscape Or KeyCode = vbKeyF12 Then Unload Me
End Sub

Private Sub Form_Unload(Cancel As Integer)
   AppIsRunning = False
   AppIsActive = False
   Call UnHookWindowProc(hWnd)
   Call fg_mousevis(1)
   Call fg_vbclose
   #If Blit Then
   Call fg_vbfree(hVB)
   #End If
   Call fg_vbfin
End Sub

'****************************************************************************\
'                                                                            *
'  Animate()                                                                 *
'                                                                            *
'  Construct the next frame of animation and display it with either blitting *
'  or flipping, as directed by the BLIT and FLIP symbols above.              *
'                                                                            *
'****************************************************************************/

Private Sub Animate()
   ' fill drawing surface with the next color
   Call fg_setcolor((fg_getcolor() + 1) And &HFF)
   Call fg_fillpage

   ' blit or flip surface to the screen
   #If Blit Then
   Call fg_vbpaste(0, vbWidth - 1, 0, vbHeight - 1, 0, vbHeight - 1)
   #Else
   Call fg_ddflip
   #End If
End Sub
