// MainFrame.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ImgProc.h"

#include "MainFrame.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)
BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_SETFOCUS()
	ON_WM_CREATE()
	ON_COMMAND(IDM_File_Open, FileOpenClick)
	ON_COMMAND(IDM_File_SaveAs, FileSaveAsClick)
	ON_COMMAND(IDM_File_Details, FileDetailsClick)
	ON_COMMAND(IDM_File_Exit, FileExitClick)
	ON_COMMAND(IDM_Edit_Undo, EditUndoClick)
	ON_COMMAND(IDM_Edit_RestoreOriginal, EditRestoreOriginalClick)
	ON_COMMAND(IDM_Edit_ContrastEnhancement, EditContrastEnhancementClick)
	ON_COMMAND(IDM_Edit_GammaCorrection, EditGammaCorrectionClick)
	ON_COMMAND(IDM_Edit_Grayscale, EditGrayscaleClick)
	ON_COMMAND(IDM_Edit_PhotoInversion, EditPhotoInversionClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	CFrameWnd::m_bAutoMenuEnable = FALSE;
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CFrameWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE |
		WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_THICKFRAME;
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnUpdateFrameTitle(BOOL bAddToTitle)
{
	CFrameWnd::OnUpdateFrameTitle(bAddToTitle);
}

void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CMainFrame::EnableItem(UINT nID, UINT nEnable)
{
	CMenu* pMenu = GetMenu();
	if (pMenu)
	{
		pMenu->EnableMenuItem(nID,nEnable);
		DrawMenuBar();
	}
}

void CMainFrame::FileOpenClick()
{
	if (m_wndView.FileOpenClick())
	{
		// enable remaining items on the File menu, and the image processing
		// items on the Edit menu
		EnableItem(IDM_File_SaveAs,MF_ENABLED);
		EnableItem(IDM_File_Details,MF_ENABLED);
		EnableItem(IDM_Edit_Undo,MF_GRAYED);
		EnableItem(IDM_Edit_RestoreOriginal,MF_GRAYED);
		EnableItem(IDM_Edit_ContrastEnhancement,MF_ENABLED);
		EnableItem(IDM_Edit_GammaCorrection,MF_ENABLED);
		EnableItem(IDM_Edit_Grayscale,MF_ENABLED);
		EnableItem(IDM_Edit_PhotoInversion,MF_ENABLED);
	}
}

void CMainFrame::FileSaveAsClick()
{
	m_wndView.FileSaveAsClick();
}

void CMainFrame::FileDetailsClick()
{
	m_wndView.FileDetailsClick();
}

void CMainFrame::FileExitClick()
{
	PostMessage(WM_CLOSE);
}

/****************************************************************************\
*                                                                            *
*  Event handlers for the items on the Edit menu.                            *
*                                                                            *
\****************************************************************************/

void CMainFrame::EditUndoClick()
{
	m_wndView.EditUndoClick();
	EnableItem(IDM_Edit_Undo,MF_GRAYED);
	EnableItem(IDM_Edit_RestoreOriginal,MF_ENABLED);
}

void CMainFrame::EditRestoreOriginalClick()
{
	m_wndView.EditRestoreOriginalClick();
	EnableItem(IDM_Edit_Undo,MF_ENABLED);
	EnableItem(IDM_Edit_RestoreOriginal,MF_GRAYED);
}

void CMainFrame::EditContrastEnhancementClick()
{
	m_wndView.EditContrastEnhancementClick();
	EnableItem(IDM_Edit_Undo,MF_ENABLED);
	EnableItem(IDM_Edit_RestoreOriginal,MF_ENABLED);
}

void CMainFrame::EditGammaCorrectionClick()
{
	m_wndView.EditGammaCorrectionClick();
	EnableItem(IDM_Edit_Undo,MF_ENABLED);
	EnableItem(IDM_Edit_RestoreOriginal,MF_ENABLED);
}

void CMainFrame::EditGrayscaleClick()
{
	m_wndView.EditGrayscaleClick();
	EnableItem(IDM_Edit_Undo,MF_ENABLED);
	EnableItem(IDM_Edit_RestoreOriginal,MF_ENABLED);
}

void CMainFrame::EditPhotoInversionClick()
{
	m_wndView.EditPhotoInversionClick();
	EnableItem(IDM_Edit_Undo,MF_ENABLED);
	EnableItem(IDM_Edit_RestoreOriginal,MF_ENABLED);
}
