'*****************************************************************************
'                                                                            *
'  MCdemo.bas                                                                *
'                                                                            *
'  This program shows how to change the shape of the mouse cursor.           *
'  Fontdemo.bas                                                              *
'                                                                            *
'*****************************************************************************

#COMPILE EXE "MCdemo.exe"

#INCLUDE "FGWin.inc"

%vbWidth = 320
%vbHeight = 240

GLOBAL Cross() AS WORD

'------------------------------------------------------------------------------

FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

  LOCAL Msg         AS tagMsg
  LOCAL winclass    AS WndClassEx
  LOCAL szClassName AS ASCIIZ * 80
  LOCAL hWnd        AS LONG

  DIM Cross(1:32)

  szClassName            = "FGmcdemo"

  winclass.cbSize        = SIZEOF(winclass)
  winclass.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_OWNDC
  winclass.lpfnWndProc   = CODEPTR(WindowProc)
  winclass.cbClsExtra    = 0
  winclass.cbWndExtra    = 0
  winclass.hInstance     = hInstance
  winclass.hIcon         = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)
  winclass.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
  winclass.hbrBackground = %NULL
  winclass.lpszMenuName  = %NULL
  winclass.lpszClassName = VARPTR(szClassName)
  winclass.hIconSm       = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)
  RegisterClassEx winclass

  hWnd = CreateWindow( _
    szClassName, _               ' window class name
    "Mouse Cursor Demo", _       ' window caption
    %WS_OVERLAPPEDWINDOW, _      ' window style
    %CW_USEDEFAULT, _            ' initial x position
    %CW_USEDEFAULT, _            ' initial y position
    %CW_USEDEFAULT, _            ' initial x size
    %CW_USEDEFAULT, _            ' initial y size
    %NULL, _                     ' parent window handle
    %NULL, _                     ' window menu handle
    hInstance, _                 ' program instance handle
    BYVAL %NULL)                 ' creation parameters

  ShowWindow hWnd, iCmdShow
  UpdateWindow hWnd

  WHILE GetMessage(Msg, %NULL, 0, 0)
    TranslateMessage Msg
    DispatchMessage Msg
  WEND

  FUNCTION = Msg.wParam

END FUNCTION

'------------------------------------------------------------------------------

GLOBAL hCursor AS LONG
GLOBAL hDC AS LONG
GLOBAL hPal AS LONG
GLOBAL hVB AS LONG
GLOBAL cxClient AS LONG, cyClient AS LONG

FUNCTION WindowProc (BYVAL hWnd AS LONG, BYVAL iMsg AS LONG, _
                     BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

  LOCAL ps AS PAINTSTRUCT

  SELECT CASE iMsg

    CASE %WM_CREATE
      hDC = GetDC(hWnd)
      fg_setdc hDC
      hPal = fg_defpal()
      fg_realize hPal

      fg_vbinit
      hVB = fg_vballoc(%vbWidth, %vbHeight)
      fg_vbopen hVB
      fg_vbcolors

      fg_setcolor 20
      fg_fillpage

      Cross(1)=&hE03F:  Cross(2)=&hE03F:  Cross(3)=&hE03F:  Cross(4)=&h0007
      Cross(5)=&h0007:  Cross(6)=&h0007:  Cross(7)=&h0007:  Cross(8)=&h0007
      Cross(9)=&h0007:  Cross(10)=&h0007: Cross(11)=&hE03F: Cross(12)=&hE03F
      Cross(13)=&hE03F: Cross(14)=&hFFFF: Cross(15)=&hFFFF: Cross(16)=&hFFFF
      Cross(17)=&h0000: Cross(18)=&h0F80: Cross(19)=&h0F80: Cross(20)=&h0F80
      Cross(21)=&h7FF0: Cross(22)=&h7FF0: Cross(23)=&h7FF0: Cross(24)=&h7FF0
      Cross(25)=&h7FF0: Cross(26)=&h0F80: Cross(27)=&h0F80: Cross(28)=&h0F80
      Cross(29)=&h0000: Cross(30)=&h0000: Cross(31)=&h0000: Cross(32)=&h0000

      fg_mouseini
      hCursor = fg_mouseptr(Cross(1), 6, 6)
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_PAINT
      BeginPaint hWnd, ps
      fg_vbscale 0, %vbWidth-1, 0, %vbHeight-1, 0, cxClient-1, 0, cyClient-1
      EndPaint hWnd, ps
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_SETCURSOR
      IF LOWRD(lParam) = %HTCLIENT THEN
         fg_mousecur hCursor
         FUNCTION = 0
         EXIT FUNCTION
      END IF

    CASE %WM_SETFOCUS
      fg_realize hPal
      InvalidateRect hWnd, BYVAL %NULL, %TRUE
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_SIZE
      cxClient = LOWRD(lParam)
      cyClient = HIWRD(lParam)
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_DESTROY
      fg_vbclose
      fg_vbfree hVB
      fg_vbfin
      DeleteObject hPal
      ReleaseDC hWnd, hDC
      PostQuitMessage 0
      FUNCTION = 0
      EXIT FUNCTION

  END SELECT

  FUNCTION = DefWindowProc(hWnd, iMsg, wParam, lParam)

END FUNCTION
