'*****************************************************************************
'                                                                            *
'  Monomap.bas                                                               *
'                                                                            *
'  This program demonstrates the Fastgraph for Windows monochrome bitmap     *
'  display functions.                                                        *
'                                                                            *
'*****************************************************************************

#COMPILE EXE "Monomap.exe"

#INCLUDE "FGWin.inc"
#RESOURCE "Monomap.pbr"

%vbWidth = 320
%vbHeight = 200

GLOBAL Hello() AS BYTE

'------------------------------------------------------------------------------
' Menu identifiers much match those in Monomap.h
%IDM_Drawmap = 1
%IDM_Clipmap = 2
%IDM_Exit    = 3

'------------------------------------------------------------------------------

FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

  LOCAL Msg         AS tagMsg
  LOCAL winclass    AS WndClassEx
  LOCAL szClassName AS ASCIIZ * 80
  LOCAL hWnd        AS LONG

  DIM Hello(0:39)

  szClassName            = "FGmonomap"

  winclass.cbSize        = SIZEOF(winclass)
  winclass.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_OWNDC
  winclass.lpfnWndProc   = CODEPTR(WindowProc)
  winclass.cbClsExtra    = 0
  winclass.cbWndExtra    = 0
  winclass.hInstance     = hInstance
  winclass.hIcon         = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)
  winclass.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
  winclass.hbrBackground = %NULL
  winclass.lpszMenuName  = VARPTR(szClassName)
  winclass.lpszClassName = VARPTR(szClassName)
  winclass.hIconSm       = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)
  RegisterClassEx winclass

  hWnd = CreateWindow( _
    szClassName, _               ' window class name
    "Monochrome Bitmap Demo", _  ' window caption
    %WS_OVERLAPPEDWINDOW, _      ' window style
    %CW_USEDEFAULT, _            ' initial x position
    %CW_USEDEFAULT, _            ' initial y position
    %CW_USEDEFAULT, _            ' initial x size
    %CW_USEDEFAULT, _            ' initial y size
    %NULL, _                     ' parent window handle
    %NULL, _                     ' window menu handle
    hInstance, _                 ' program instance handle
    BYVAL %NULL)                 ' creation parameters

  ShowWindow hWnd, iCmdShow
  UpdateWindow hWnd

  WHILE GetMessage(Msg, %NULL, 0, 0)
    TranslateMessage Msg
    DispatchMessage Msg
  WEND

  FUNCTION = Msg.wParam

END FUNCTION

'------------------------------------------------------------------------------

GLOBAL hDC AS LONG
GLOBAL hPal AS LONG
GLOBAL hVB AS LONG
GLOBAL cxClient AS LONG, cyClient AS LONG

FUNCTION WindowProc (BYVAL hWnd AS LONG, BYVAL iMsg AS LONG, _
                     BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

  LOCAL ps AS PAINTSTRUCT

  SELECT CASE iMsg

    CASE %WM_CREATE
      hDC = GetDC(hWnd)
      fg_setdc hDC
      hPal = fg_defpal()
      fg_realize hPal

      fg_vbinit
      hVB = fg_vballoc(%vbWidth, %vbHeight)
      fg_vbopen hVB
      fg_vbcolors

      fg_setcolor 25
      fg_fillpage
      CALL LoadHello
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_COMMAND
      SELECT CASE wParam

        CASE %IDM_Drawmap
          CALL Drawmap_Click

        CASE %IDM_Clipmap
          CALL Clipmap_Click

        CASE %IDM_Exit
          DestroyWindow hWnd
      END SELECT
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_PAINT
      BeginPaint hWnd, ps
      fg_vbscale 0, %vbWidth-1, 0, %vbHeight-1, 0, cxClient-1, 0, cyClient-1
      EndPaint hWnd, ps
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_SETFOCUS
      fg_realize hPal
      InvalidateRect hWnd, BYVAL %NULL, %TRUE
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_SIZE
      cxClient = LOWRD(lParam)
      cyClient = HIWRD(lParam)
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_DESTROY
      fg_vbclose
      fg_vbfree hVB
      fg_vbfin
      DeleteObject hPal
      ReleaseDC hWnd, hDC
      PostQuitMessage 0
      FUNCTION = 0
      EXIT FUNCTION

  END SELECT

  FUNCTION = DefWindowProc(hWnd, iMsg, wParam, lParam)

END FUNCTION

SUB Clipmap_Click()
   fg_setcolor 25
   fg_fillpage
   fg_setcolor 22
   fg_move -12, %vbHeight/2 + 4
   fg_clipmap Hello(0), 5, 8
   fg_vbscale 0, %vbWidth-1, 0, %vbHeight-1, 0, cxClient-1, 0, cyClient-1
END SUB

SUB Drawmap_Click()
   fg_setcolor 25
   fg_fillpage
   fg_setcolor 10
   fg_move %vbWidth/2 - 20, %vbHeight/2 + 4
   fg_drawmap Hello(0), 5, 8
   fg_vbscale 0, %vbWidth-1, 0, %vbHeight-1, 0, cxClient-1, 0, cyClient-1
END SUB

SUB LoadHello()
   Hello(0) =&h00: Hello(1) =&h00: Hello(2) =&h00: Hello(3) =&h00: Hello(4) =&h00
   Hello(5) =&hCC: Hello(6) =&h78: Hello(7) =&h78: Hello(8) =&h78: Hello(9) =&h78
   Hello(10)=&hCC: Hello(11)=&hC0: Hello(12)=&h30: Hello(13)=&h30: Hello(14)=&hCC
   Hello(15)=&hCC: Hello(16)=&hFC: Hello(17)=&h30: Hello(18)=&h30: Hello(19)=&hCC
   Hello(20)=&hFC: Hello(21)=&hCC: Hello(22)=&h30: Hello(23)=&h30: Hello(24)=&hCC
   Hello(25)=&hCC: Hello(26)=&h78: Hello(27)=&h30: Hello(28)=&h30: Hello(29)=&h78
   Hello(30)=&hCC: Hello(31)=&h00: Hello(32)=&h30: Hello(33)=&h30: Hello(34)=&h00
   Hello(35)=&hCC: Hello(36)=&h00: Hello(37)=&h70: Hello(38)=&h70: Hello(39)=&h00
END SUB
