/****************************************************************************\
*                                                                            *
*  Monomap.cs                                                                *
*                                                                            *
*  This program demonstrates the Fastgraph for Windows monochrome bitmap     *
*  display functions.                                                        *
*                                                                            *
\****************************************************************************/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace Monomap
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		// Fastgraph variables.
		Graphics g;
		IntPtr hDC;
		int hPal;
		int hVB;
		int cxClient, cyClient;

		// Virtual buffer dimensions.
		const int vbWidth = 320;
		const int vbHeight = 200;

		// Application variables.
		byte [] Hello = {
			0x00,0x00,0x00,0x00,0x00,
			0xCC,0x78,0x78,0x78,0x78,
			0xCC,0xC0,0x30,0x30,0xCC,
			0xCC,0xFC,0x30,0x30,0xCC,
			0xFC,0xCC,0x30,0x30,0xCC,
			0xCC,0x78,0x30,0x30,0x78,
			0xCC,0x00,0x30,0x30,0x00,
			0xCC,0x00,0x70,0x70,0x00};

		// Component declarations.
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuClipmap;
		private System.Windows.Forms.MenuItem menuDrawmap;
		private System.Windows.Forms.MenuItem menuExit;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Add any constructor code after InitializeComponent call
			//
			g = CreateGraphics();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			g.Dispose();
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuClipmap = new System.Windows.Forms.MenuItem();
			this.menuDrawmap = new System.Windows.Forms.MenuItem();
			this.menuExit = new System.Windows.Forms.MenuItem();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuClipmap,
																					  this.menuDrawmap,
																					  this.menuExit});
			// 
			// menuClipmap
			// 
			this.menuClipmap.Index = 0;
			this.menuClipmap.Text = "&Clipmap";
			this.menuClipmap.Click += new System.EventHandler(this.menuClipmap_Click);
			// 
			// menuDrawmap
			// 
			this.menuDrawmap.Index = 1;
			this.menuDrawmap.Text = "&Drawmap";
			this.menuDrawmap.Click += new System.EventHandler(this.menuDrawmap_Click);
			// 
			// menuExit
			// 
			this.menuExit.Index = 2;
			this.menuExit.Text = "E&xit";
			this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(446, 256);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Monochrome Bitmap Demo";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Closed += new System.EventHandler(this.Form1_Closed);
			this.Activated += new System.EventHandler(this.Form1_Activated);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Activated(object sender, System.EventArgs e)
		{
			fg.realize(hPal);
			cxClient = ClientRectangle.Width;
			cyClient = ClientRectangle.Height;
			Refresh();
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			hDC = g.GetHdc();
			fg.setdc(hDC);
			hPal = fg.defpal();
			fg.realize(hPal);

			fg.vbinit();
			hVB = fg.vballoc(vbWidth, vbHeight);
			fg.vbopen(hVB);
			fg.vbcolors();

			fg.setcolor(25);
			fg.fillpage();
		}

		private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			fg.vbscale(0, vbWidth-1, 0, vbHeight-1, 0, cxClient-1, 0, cyClient-1);
		}

		private void Form1_Resize(object sender, System.EventArgs e)
		{
			cxClient = ClientRectangle.Width;
			cyClient = ClientRectangle.Height;
			fg.vbscale(0, vbWidth-1, 0, vbHeight-1, 0, cxClient-1, 0, cyClient-1);
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			fg.vbclose();
			fg.vbfree(hVB);
			fg.vbfin();
			g.ReleaseHdc(hDC);
		}

		private void menuClipmap_Click(object sender, System.EventArgs e)
		{
			fg.setcolor(25);
			fg.fillpage();
			fg.setcolor(22);
			fg.move(-12, vbHeight/2 + 4);
			fg.clipmap(ref Hello[0], 5, 8);
			fg.vbscale(0, vbWidth-1, 0, vbHeight-1, 0, cxClient-1, 0, cyClient-1);
		}

		private void menuDrawmap_Click(object sender, System.EventArgs e)
		{
			fg.setcolor(25);
			fg.fillpage();
			fg.setcolor(10);
			fg.move(vbWidth/2 - 20, vbHeight/2 + 4);
			fg.drawmap(ref Hello[0], 5, 8);
			fg.vbscale(0, vbWidth-1, 0, vbHeight-1, 0, cxClient-1, 0, cyClient-1);
		}

		private void menuExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
