'*****************************************************************************
'                                                                            *
'  Monomap.vb                                                                *
'                                                                            *
'  This program demonstrates the Fastgraph for Windows monochrome bitmap     *
'  display functions.                                                        *
'                                                                            *
'*****************************************************************************
Public Class Form1
    Inherits System.Windows.Forms.Form

    ' Fastgraph variables.
    Dim g As Graphics
    Dim hDC As IntPtr
    Dim hPal As Integer
    Dim hVB As Integer
    Dim cxClient, cyClient As Integer

    ' Virtual buffer dimensions.
    Const vbWidth As Integer = 320
    Const vbHeight As Integer = 200

    ' Application variables.
    Dim Hello() As Byte = { _
        &H0, &H0, &H0, &H0, &H0, _
        &HCC, &H78, &H78, &H78, &H78, _
        &HCC, &HC0, &H30, &H30, &HCC, _
        &HCC, &HFC, &H30, &H30, &HCC, _
        &HFC, &HCC, &H30, &H30, &HCC, _
        &HCC, &H78, &H30, &H30, &H78, _
        &HCC, &H0, &H30, &H30, &H0, _
        &HCC, &H0, &H70, &H70, &H0}

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        g = Me.CreateGraphics

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        g.Dispose()
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents menuClipmap As System.Windows.Forms.MenuItem
    Friend WithEvents menuDrawmap As System.Windows.Forms.MenuItem
    Friend WithEvents menuExit As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu()
        Me.menuClipmap = New System.Windows.Forms.MenuItem()
        Me.menuDrawmap = New System.Windows.Forms.MenuItem()
        Me.menuExit = New System.Windows.Forms.MenuItem()
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuClipmap, Me.menuDrawmap, Me.menuExit})
        '
        'menuClipmap
        '
        Me.menuClipmap.Index = 0
        Me.menuClipmap.Text = "&Clipmap"
        '
        'menuDrawmap
        '
        Me.menuDrawmap.Index = 1
        Me.menuDrawmap.Text = "&Drawmap"
        '
        'menuExit
        '
        Me.menuExit.Index = 2
        Me.menuExit.Text = "E&xit"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(446, 276)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "Monochrome Bitmap Demo"

    End Sub

#End Region

    Private Sub Form1_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Activated
        fg_realize(hPal)
        cxClient = ClientRectangle.Width
        cyClient = ClientRectangle.Height
        Refresh()
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        hDC = g.GetHdc()
        fg_setdc(hDC)
        hPal = fg_defpal()
        fg_realize(hPal)

        fg_vbinit()
        hVB = fg_vballoc(vbWidth, vbHeight)
        fg_vbopen(hVB)
        fg_vbcolors()

        fg_setcolor(25)
        fg_fillpage()
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        cxClient = ClientRectangle.Width
        cyClient = ClientRectangle.Height
        fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
    End Sub

    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        fg_vbclose()
        fg_vbfree(hVB)
        fg_vbfin()
        g.ReleaseHdc(hDC)
    End Sub

    Private Sub menuClipmap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuClipmap.Click
        fg_setcolor(25)
        fg_fillpage()
        fg_setcolor(22)
        fg_move(-12, vbHeight \ 2 + 4)
        fg_clipmap(Hello(0), 5, 8)
        fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
    End Sub

    Private Sub menuDrawmap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuDrawmap.Click
        fg_setcolor(25)
        fg_fillpage()
        fg_setcolor(10)
        fg_move(vbWidth \ 2 - 20, vbHeight \ 2 + 4)
        fg_drawmap(Hello(0), 5, 8)
        fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
    End Sub

    Private Sub menuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuExit.Click
        Me.Close()
    End Sub
End Class