{*****************************************************************************
*                                                                            *
*  Monomap.dpr                                                               *
*  MonomapU.pas                                                              *
*                                                                            *
*  This program demonstrates the Fastgraph for Windows monochrome bitmap     *
*  display functions.                                                        *
*                                                                            *
*****************************************************************************}

unit MonomapU;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, FGWin;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Drawmap: TMenuItem;
    Clipmap: TMenuItem;
    Exit1: TMenuItem;
    procedure AppOnActivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DrawmapClick(Sender: TObject);
    procedure ClipmapClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$J+}
{$R *.DFM}
const
  vbWidth  = 320;
  vbHeight = 200;

  Hello : array [1..40] of byte = (
    $00,$00,$00,$00,$00,
    $CC,$78,$78,$78,$78,
    $CC,$C0,$30,$30,$CC,
    $CC,$FC,$30,$30,$CC,
    $FC,$CC,$30,$30,$CC,
    $CC,$78,$30,$30,$78,
    $CC,$00,$30,$30,$00,
    $CC,$00,$70,$70,$00);

var
  dc   : hDC;
  hPal : hPalette;
  hVB  : integer;
  cxClient, cyClient : integer;

procedure TForm1.AppOnActivate(Sender: TObject);
begin
  fg_realize(hPal);
  Invalidate;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  fg_realize(hPal);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  dc := GetDC(Form1.Handle);
  fg_setdc(dc);
  hPal := fg_defpal;
  fg_realize(hPal);

  fg_vbinit;
  hVB := fg_vballoc(vbWidth,vbHeight);
  fg_vbopen(hVB);
  fg_vbcolors;

  fg_setcolor(25);
  fg_fillpage;
  Application.OnActivate := AppOnActivate;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  fg_vbscale(0,vbWidth-1,0,vbHeight-1,0,cxClient-1,0,cyClient-1);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  cxClient := ClientWidth;
  cyClient := ClientHeight;
  Invalidate;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  fg_vbclose;
  fg_vbfree(hVB);
  fg_vbfin;
  DeleteObject(hPal);
  ReleaseDC(Form1.Handle,dc);
end;

procedure TForm1.DrawmapClick(Sender: TObject);
begin
  fg_setcolor(25);
  fg_fillpage;
  fg_setcolor(10);
  fg_move(vbWidth div 2 - 20,vbHeight div 2 + 4);
  fg_drawmap(Hello,5,8);
  fg_vbscale(0,vbWidth-1,0,vbHeight-1,0,cxClient-1,0,cyClient-1);
end;

procedure TForm1.ClipmapClick(Sender: TObject);
begin
  fg_setcolor(25);
  fg_fillpage;
  fg_setcolor(22);
  fg_move(-12,vbHeight div 2 + 4);
  fg_clipmap(Hello,5,8);
  fg_vbscale(0,vbWidth-1,0,vbHeight-1,0,cxClient-1,0,cyClient-1);
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
  Close;
end;

end.
