'*****************************************************************************
'                                                                            *
'  SWchars.bas                                                               *
'                                                                            *
'  This program displays all characters in the Fastgraph for Windows primary *
'  and alternate software fonts.                                             *
'                                                                            *
'*****************************************************************************

#COMPILE EXE "SWchars.exe"

#INCLUDE "FGWin.inc"

%vbWidth = 640
%vbHeight = 480

'------------------------------------------------------------------------------

FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

  LOCAL Msg         AS tagMsg
  LOCAL winclass    AS WndClassEx
  LOCAL szClassName AS ASCIIZ * 80
  LOCAL hWnd        AS LONG

  szClassName            = "FGswchars"

  winclass.cbSize        = SIZEOF(winclass)
  winclass.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_OWNDC
  winclass.lpfnWndProc   = CODEPTR(WindowProc)
  winclass.cbClsExtra    = 0
  winclass.cbWndExtra    = 0
  winclass.hInstance     = hInstance
  winclass.hIcon         = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)
  winclass.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
  winclass.hbrBackground = %NULL
  winclass.lpszMenuName  = %NULL
  winclass.lpszClassName = VARPTR(szClassName)
  winclass.hIconSm       = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)
  RegisterClassEx winclass

  hWnd = CreateWindow( _
    szClassName, _               ' window class name
    "Software Character Set", _  ' window caption
    %WS_OVERLAPPEDWINDOW, _      ' window style
    %CW_USEDEFAULT, _            ' initial x position
    %CW_USEDEFAULT, _            ' initial y position
    %vbWidth, _                  ' initial x size
    %vbHeight, _                 ' initial y size
    %NULL, _                     ' parent window handle
    %NULL, _                     ' window menu handle
    hInstance, _                 ' program instance handle
    BYVAL %NULL)                 ' creation parameters

  ShowWindow hWnd, iCmdShow
  UpdateWindow hWnd

  WHILE GetMessage(Msg, %NULL, 0, 0)
    TranslateMessage Msg
    DispatchMessage Msg
  WEND

  FUNCTION = Msg.wParam

END FUNCTION

'------------------------------------------------------------------------------

GLOBAL hDC AS LONG
GLOBAL hPal AS LONG
GLOBAL hVB AS LONG
GLOBAL xDest AS LONG, yDest AS LONG

FUNCTION WindowProc (BYVAL hWnd AS LONG, BYVAL iMsg AS LONG, _
                     BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

  LOCAL ps AS PAINTSTRUCT

  SELECT CASE iMsg

    CASE %WM_CREATE
      hDC = GetDC(hWnd)
      fg_setdc hDC
      hPal = fg_defpal()
      fg_realize hPal

      fg_vbinit
      hVB = fg_vballoc(%vbWidth, %vbHeight)
      fg_vbopen hVB
      fg_vbcolors

      fg_initw
      fg_setworld 0.0, 6.39, 0.0, 4.79
      fg_setsizew 0.2

      fg_setcolor 25
      fg_fillpage
      fg_setcolor 19

      fg_movew 3.2, 4.2
      fg_swchar "Software characters - font 1", 28, 0
      fg_setcolor 10
      fg_movew 0.5, 3.9
      fg_swchar "ABCDEFGHIJKLMNOPQRSTUVWXYZ", 26, -1
      fg_movew 0.5, 3.6
      fg_swchar "abcdefghijklmnopqrstuvwxyz", 26, -1
      fg_movew 0.5, 3.3
      fg_swchar "0123456789", 10, -1
      fg_movew 0.5, 3.0
      fg_swchar "!""#$%&='()*+,-./:;<=>?[]^`{|}~", 29, -1

      fg_setcolor 19
      fg_movew 3.2, 2.5
      fg_swchar "Software characters - font 2", 28, 0
      fg_setcolor 10
      fg_movew 0.5, 2.2
      fg_swchar "\ABCDEFGHIJKLMNOPRSTUWXYZ", 25, -1
      fg_movew 0.5, 1.9
      fg_swchar "\abcdefghijklmnoprstuwxyz", 25, -1
      fg_movew 0.5, 1.3
      fg_swchar "\012345678#$%&()*+/<=>?[]{}", 27, -1

      fg_setratio 1.2
      fg_movew 0.5, 0.6
      fg_swchar "cos\^2\h\+sin\^2\h\=1", 21, -1

      fg_movew 5.9, 0.6
      fg_swchar "H\v2O U\v2\v3\v2", 16, 1

      fg_setratio 1.0
      fg_movew 3.2, 0.2
      fg_swchar "One _word_ is underlined.", 25, 0

      fg_setcolor 19
      fg_movew 0.0, 2.8
      fg_draww 6.39, 2.8
      fg_movew 0.0, 0.9
      fg_draww 6.39, 0.9
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_PAINT
      BeginPaint hWnd, ps
      fg_vbpaste 0, %vbWidth-1, 0, %vbHeight-1, xDest, yDest
      EndPaint hWnd, ps
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_SETFOCUS
      fg_realize hPal
      InvalidateRect hWnd, BYVAL %NULL, %TRUE
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_SIZE
      xDest = (LOWRD(lParam) - %vbWidth) / 2
      yDest = (HIWRD(lParam) - %vbHeight) / 2
      IF xDest < 0 THEN xDest = 0
      IF yDest < 0 THEN yDest = 0
      yDest = (HIWRD(lParam) - 1) - yDest
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_DESTROY
      fg_vbclose
      fg_vbfree hVB
      fg_vbfin
      DeleteObject hPal
      ReleaseDC hWnd, hDC
      PostQuitMessage 0
      FUNCTION = 0
      EXIT FUNCTION

  END SELECT

  FUNCTION = DefWindowProc(hWnd, iMsg, wParam, lParam)

END FUNCTION
