'*****************************************************************************
'                                                                            *
'  Strings1.bas                                                              *
'                                                                            *
'  This program shows how to display strings in the client area.             *
'                                                                            *
'*****************************************************************************

#COMPILE EXE "Strings1.exe"

#INCLUDE "FGWin.inc"

%vbWidth = 320
%vbHeight = 240

'------------------------------------------------------------------------------

FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

  LOCAL Msg         AS tagMsg
  LOCAL winclass    AS WndClassEx
  LOCAL szClassName AS ASCIIZ * 80
  LOCAL hWnd        AS LONG

  szClassName            = "FGstrings1"

  winclass.cbSize        = SIZEOF(winclass)
  winclass.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_OWNDC
  winclass.lpfnWndProc   = CODEPTR(WindowProc)
  winclass.cbClsExtra    = 0
  winclass.cbWndExtra    = 0
  winclass.hInstance     = hInstance
  winclass.hIcon         = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)
  winclass.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
  winclass.hbrBackground = %NULL
  winclass.lpszMenuName  = %NULL
  winclass.lpszClassName = VARPTR(szClassName)
  winclass.hIconSm       = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)
  RegisterClassEx winclass

  hWnd = CreateWindow( _
    szClassName, _               ' window class name
    "Display Strings in Client Area", _ ' window caption
    %WS_OVERLAPPEDWINDOW, _      ' window style
    %CW_USEDEFAULT, _            ' initial x position
    %CW_USEDEFAULT, _            ' initial y position
    %CW_USEDEFAULT, _            ' initial x size
    %CW_USEDEFAULT, _            ' initial y size
    %NULL, _                     ' parent window handle
    %NULL, _                     ' window menu handle
    hInstance, _                 ' program instance handle
    BYVAL %NULL)                 ' creation parameters

  ShowWindow hWnd, iCmdShow
  UpdateWindow hWnd

  WHILE GetMessage(Msg, %NULL, 0, 0)
    TranslateMessage Msg
    DispatchMessage Msg
  WEND

  FUNCTION = Msg.wParam

END FUNCTION

'------------------------------------------------------------------------------

GLOBAL hDC AS LONG
GLOBAL hPal AS LONG
GLOBAL hVB AS LONG
GLOBAL cxClient AS LONG, cyClient AS LONG

FUNCTION WindowProc (BYVAL hWnd AS LONG, BYVAL iMsg AS LONG, _
                     BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

  LOCAL ps AS PAINTSTRUCT

  SELECT CASE iMsg

    CASE %WM_CREATE
      hDC = GetDC(hWnd)
      fg_setdc hDC
      hPal = fg_defpal()
      fg_realize hPal

      fg_vbinit
      hVB = fg_vballoc(%vbWidth, %vbHeight)
      fg_vbopen hVB
      fg_vbcolors

      fg_setcolor 24
      fg_fillpage
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_PAINT
      BeginPaint hWnd, ps
      fg_vbscale 0, %vbWidth-1, 0, %vbHeight-1, 0, cxClient-1, 0, cyClient-1
      CALL DrawStrings
      EndPaint hWnd, ps
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_SETFOCUS
      fg_realize hPal
      InvalidateRect hWnd, BYVAL %NULL, %TRUE
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_SIZE
      cxClient = LOWRD(lParam)
      cyClient = HIWRD(lParam)
      FUNCTION = 0
      EXIT FUNCTION

    CASE %WM_DESTROY
      fg_vbclose
      fg_vbfree hVB
      fg_vbfin
      DeleteObject hPal
      ReleaseDC hWnd, hDC
      PostQuitMessage 0
      FUNCTION = 0
      EXIT FUNCTION

  END SELECT

  FUNCTION = DefWindowProc(hWnd, iMsg, wParam, lParam)

END FUNCTION

SUB DrawStrings()
   fg_setcolor 19

   ' upper vertical justification
   fg_move fg_xclient(0), fg_yclient(0)
   fg_justify -1, 1
   fg_print "FG/Windows", 10
   fg_move fg_xclient(%vbWidth/2), fg_yclient(0)
   fg_justify 0, 1
   fg_print "FG/Windows", 10
   fg_move fg_xclient(%vbWidth-1), fg_yclient(0)
   fg_justify 1, 1
   fg_print "FG/Windows", 10

   ' centered vertical justification
   fg_move fg_xclient(0), fg_yclient(%vbHeight/2)
   fg_justify -1, 0
   fg_print "FG/Windows", 10
   fg_move fg_xclient(%vbWidth/2), fg_yclient(%vbHeight/2)
   fg_justify 0, 0
   fg_print "FG/Windows", 10
   fg_move fg_xclient(%vbWidth-1), fg_yclient(%vbHeight/2)
   fg_justify 1, 0
   fg_print "FG/Windows", 10

   ' lower vertical justification
   fg_move fg_xclient(0), fg_yclient(%vbHeight-1)
   fg_justify -1, -1
   fg_print "FG/Windows", 10
   fg_move fg_xclient(%vbWidth/2), fg_yclient(%vbHeight-1)
   fg_justify 0, -1
   fg_print "FG/Windows", 10
   fg_move fg_xclient(%vbWidth-1), fg_yclient(%vbHeight-1)
   fg_justify 1, -1
   fg_print "FG/Windows", 10
END SUB
