/****************************************************************************\
*                                                                            *
*  Strings1.cs                                                               *
*                                                                            *
*  This program shows how to display strings in the client area.             *
*                                                                            *
\****************************************************************************/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace Strings1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		// Fastgraph variables.
		Graphics g;
		IntPtr hDC;
		int hPal;
		int hVB;
		int cxClient, cyClient;

		// Virtual buffer dimensions.
		const int vbWidth = 320;
		const int vbHeight = 240;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Add any constructor code after InitializeComponent call
			//
			g = CreateGraphics();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			g.Dispose();
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(640, 480);
			this.Name = "Form1";
			this.Text = "Display Strings in Client Area";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Closed += new System.EventHandler(this.Form1_Closed);
			this.Activated += new System.EventHandler(this.Form1_Activated);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Activated(object sender, System.EventArgs e)
		{
			fg.realize(hPal);
			cxClient = ClientRectangle.Width;
			cyClient = ClientRectangle.Height;
			Refresh();
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			hDC = g.GetHdc();
			fg.setdc(hDC);
			hPal = fg.defpal();
			fg.realize(hPal);

			fg.vbinit();
			hVB = fg.vballoc(vbWidth, vbHeight);
			fg.vbopen(hVB);
			fg.vbcolors();

			fg.setcolor(24);
			fg.fillpage();
		}

		private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			fg.vbscale(0, vbWidth-1, 0, vbHeight-1, 0, cxClient-1, 0, cyClient-1);
			DrawStrings();
		}

		private void Form1_Resize(object sender, System.EventArgs e)
		{
			cxClient = ClientRectangle.Width;
			cyClient = ClientRectangle.Height;
			fg.vbscale(0, vbWidth-1, 0, vbHeight-1, 0, cxClient-1, 0, cyClient-1);
			if (this.Visible) DrawStrings();
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			fg.vbclose();
			fg.vbfree(hVB);
			fg.vbfin();
			g.ReleaseHdc(hDC);
		}

		private void DrawStrings()
		{
			fg.setcolor(19);

			// Upper vertical justification.
			fg.move(fg.xclient(0), fg.yclient(0));
			fg.justify(-1, 1);
			fg.print("FG/Windows", 10);
			fg.move(fg.xclient(vbWidth/2), fg.yclient(0));
			fg.justify(0, 1);
			fg.print("FG/Windows", 10);
			fg.move(fg.xclient(vbWidth-1), fg.yclient(0));
			fg.justify(1, 1);
			fg.print("FG/Windows", 10);

			// Centered vertical justification.
			fg.move(fg.xclient(0), fg.yclient(vbHeight/2));
			fg.justify(-1, 0);
			fg.print("FG/Windows", 10);
			fg.move(fg.xclient(vbWidth/2), fg.yclient(vbHeight/2));
			fg.justify(0, 0);
			fg.print("FG/Windows", 10);
			fg.move(fg.xclient(vbWidth-1), fg.yclient(vbHeight/2));
			fg.justify(1, 0);
			fg.print("FG/Windows", 10);

			// Lower vertical justification.
			fg.move(fg.xclient(0), fg.yclient(vbHeight-1));
			fg.justify(-1, -1);
			fg.print("FG/Windows", 10);
			fg.move(fg.xclient(vbWidth/2), fg.yclient(vbHeight-1));
			fg.justify(0, -1);
			fg.print("FG/Windows", 10);
			fg.move(fg.xclient(vbWidth-1), fg.yclient(vbHeight-1));
			fg.justify(1, -1);
			fg.print("FG/Windows", 10);
		}
	}
}