{*****************************************************************************
*                                                                            *
*  Strings1.dpr                                                              *
*  Strings1u.pas                                                             *
*                                                                            *
*  This program shows how to display strings in the client area.             *
*                                                                            *
*****************************************************************************}

unit Strings1U;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, FGWin;

type
  TForm1 = class(TForm)
    procedure AppOnActivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
const
  vbWidth  = 320;
  vbHeight = 240;

var
  dc   : hDC;
  hPal : hPalette;
  hVB  : integer;
  cxClient, cyClient : integer;

procedure DrawStrings;
begin
  fg_setcolor(19);

  { upper vertical justification }
  fg_move(fg_xclient(0),fg_yclient(0));
  fg_justify(-1,1);
  fg_print('FG/Windows',10);
  fg_move(fg_xclient(vbWidth div 2),fg_yclient(0));
  fg_justify(0,1);
  fg_print('FG/Windows',10);
  fg_move(fg_xclient(vbWidth-1),fg_yclient(0));
  fg_justify(1,1);
  fg_print('FG/Windows',10);

  { centered vertical justification }
  fg_move(fg_xclient(0),fg_yclient(vbHeight div 2));
  fg_justify(-1,0);
  fg_print('FG/Windows',10);
  fg_move(fg_xclient(vbWidth div 2),fg_yclient(vbHeight div 2));
  fg_justify(0,0);
  fg_print('FG/Windows',10);
  fg_move(fg_xclient(vbWidth-1),fg_yclient(vbHeight div 2));
  fg_justify(1,0);
  fg_print('FG/Windows',10);

  { lower vertical justification }
  fg_move(fg_xclient(0),fg_yclient(vbHeight-1));
  fg_justify(-1,-1);
  fg_print('FG/Windows',10);
  fg_move(fg_xclient(vbWidth div 2),fg_yclient(vbHeight-1));
  fg_justify(0,-1);
  fg_print('FG/Windows',10);
  fg_move(fg_xclient(vbWidth-1),fg_yclient(vbHeight-1));
  fg_justify(1,-1);
  fg_print('FG/Windows',10);
end;

{****************************************************************************}

procedure TForm1.AppOnActivate(Sender: TObject);
begin
  fg_realize(hPal);
  Invalidate;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  fg_realize(hPal);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  dc := GetDC(Form1.Handle);
  fg_setdc(dc);
  hPal := fg_defpal;
  fg_realize(hPal);

  fg_vbinit;
  hVB := fg_vballoc(vbWidth,vbHeight);
  fg_vbopen(hVB);
  fg_vbcolors;

  fg_setcolor(24);
  fg_fillpage;
  Application.OnActivate := AppOnActivate;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  fg_vbscale(0,vbWidth-1,0,vbHeight-1,0,cxClient-1,0,cyClient-1);
  DrawStrings;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  cxClient := ClientWidth;
  cyClient := ClientHeight;
  Invalidate;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  fg_vbclose;
  fg_vbfree(hVB);
  fg_vbfin;
  DeleteObject(hPal);
  ReleaseDC(Form1.Handle,dc);
end;

end.
