{*****************************************************************************
*                                                                            *
*  Strings2.dpr                                                              *
*  Strings2U.pas                                                             *
*                                                                            *
*  This program shows how to display strings in the virtual buffer.          *
*                                                                            *
*****************************************************************************}

unit Strings2U;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, FGWin;

type
  TForm1 = class(TForm)
    procedure AppOnActivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
const
  vbWidth  = 320;
  vbHeight = 240;

var
  dc   : hDC;
  hPal : hPalette;
  hVB  : integer;
  cxClient, cyClient : integer;

procedure DrawStrings;
begin
  fg_setcolor(19);

  { upper vertical justification }
  fg_move(0,0);
  fg_justify(-1,1);
  fg_print('FG/Windows',10);
  fg_move(vbWidth div 2,0);
  fg_justify(0,1);
  fg_print('FG/Windows',10);
  fg_move(vbWidth-1,0);
  fg_justify(1,1);
  fg_print('FG/Windows',10);

  { centered vertical justification }
  fg_move(0,vbHeight div 2);
  fg_justify(-1,0);
  fg_print('FG/Windows',10);
  fg_move(vbWidth div 2,vbHeight div 2);
  fg_justify(0,0);
  fg_print('FG/Windows',10);
  fg_move(vbWidth-1,vbHeight div 2);
  fg_justify(1,0);
  fg_print('FG/Windows',10);

  { lower vertical justification }
  fg_move(0,vbHeight-1);
  fg_justify(-1,-1);
  fg_print('FG/Windows',10);
  fg_move(vbWidth div 2,vbHeight-1);
  fg_justify(0,-1);
  fg_print('FG/Windows',10);
  fg_move(vbWidth-1,vbHeight-1);
  fg_justify(1,-1);
  fg_print('FG/Windows',10);
end;

{****************************************************************************}

procedure TForm1.AppOnActivate(Sender: TObject);
begin
  fg_realize(hPal);
  Invalidate;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  fg_realize(hPal);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  dc := GetDC(Form1.Handle);
  fg_setdc(dc);
  hPal := fg_defpal;
  fg_realize(hPal);

  fg_vbinit;
  hVB := fg_vballoc(vbWidth,vbHeight);
  fg_vbopen(hVB);
  fg_vbcolors;

  fg_setcolor(24);
  fg_fillpage;
  fg_fontdc(fg_getdc);
  DrawStrings;

  Application.OnActivate := AppOnActivate;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  fg_vbscale(0,vbWidth-1,0,vbHeight-1,0,cxClient-1,0,cyClient-1);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  cxClient := ClientWidth;
  cyClient := ClientHeight;
  Invalidate;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  fg_vbclose;
  fg_vbfree(hVB);
  fg_vbfin;
  DeleteObject(hPal);
  ReleaseDC(Form1.Handle,dc);
end;

end.
