/****************************************************************************\
*                                                                            *
*  TMcube.cpp                                                                *
*                                                                            *
*  This program draws a texture-mapped cube in 3D world space and allows the *
*  user to move and rotate the cube through keyboard controls. A different   *
*  texture is applied to each cube face. Supports linear or perspective      *
*  texture mapping, z-buffering, and 3D clipping through the RENDER_STATE    *
*  symbol.                                                                   *
*                                                                            *
\****************************************************************************/

// TMcube.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TMcube.h"

#include "MainFrame.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTMcubeApp

BEGIN_MESSAGE_MAP(CTMcubeApp, CWinApp)
	//{{AFX_MSG_MAP(CTMcubeApp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTMcubeApp construction

CTMcubeApp::CTMcubeApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTMcubeApp object

CTMcubeApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CTMcubeApp initialization

BOOL CTMcubeApp::InitInstance()
{
	// Standard initialization

	// Change the registry key under which our settings are stored.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	m_pMainWnd = NULL;
	CMainFrame* pFrame = new CMainFrame;

	if (!pFrame->Create(NULL,"Texture-Mapped Cube"))
		return FALSE;

	m_pMainWnd = pFrame;
	pFrame->ShowWindow(m_nCmdShow);
	pFrame->UpdateWindow();

	return TRUE;
}

int CTMcubeApp::Run()
{
	if (!m_pMainWnd)
		AfxPostQuitMessage(0);

	MSG msg;
	CMainFrame* pFrame = STATIC_DOWNCAST(CMainFrame, m_pMainWnd);

	while (TRUE)
	{
		//see if there is a message waiting
		if (::PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
		{
			do //if there is pump all waiting
			{
				if (!PumpMessage())
					return ExitInstance();
			} while (::PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE));
		}
		else
		{
			if (!pFrame->m_bAppIsActive)
				WaitMessage();
			else
				pFrame->CheckForMovement();
		}
	}
	return msg.wParam;
}

/////////////////////////////////////////////////////////////////////////////
// CTMcubeApp message handlers
